<?
/*
 ************************************************************************
 * File Name   : CounterStatic.php
 * Class Name  : KCCounterStatic
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("K_LIB_ENV"))         require("../kCounterEnv.php");
if(!defined("KCCOUNTERADMINUI"))  require(KCOUNTER_CLASS . "/KCCounterAdminUI.php");
if(!defined("KCSQLCLAUSE"))       require(K_LIB_PATH . "/KCSqlClause.php");
if(!defined("KCTEXTBOX"))         require(K_LIB_PATH . "/KCTextBox.php");
if(!defined("KCCOUNTERMNG"))      require(KCOUNTER_CLASS . "/KCCounterMng.php");

define("KCCOUNTERSTATIC", true);
class KCCounterStatic extends KCCounterAdminUI
{
    var $m_SearchFlag;
    var $m_CounterName;
    var $m_CountStatic;
    var $m_StaticDate;
    
    var $m_StaticDateYear;
    var $m_StaticDateMonth;
    var $m_StaticDateDay;
    
    var $COUNT_STATIC_YEAR  = "csy";
    var $COUNT_STATIC_MONTH = "csm";
    var $COUNT_STATIC_DAY   = "csd";
    var $COUNT_STATIC_HOUR  = "csh";
    var $COUNT_STATIC_WEEK  = "csw";
    var $COUNT_STATIC_TOTAL = "csg";  
    
   
    var $m_DateType;
    var $m_OuterJoinDateFormat;
    var $m_TotalStaticFormat;
    var $m_StaticTotalCount;
    var $m_StaticTitle;
    
    
    var $STATIC_MAX_LENGTH  = 350 ;
  
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCounterStatic()
    {
        $this->KCCounterAdminUI();
        $this->m_ViewTitleImage = false;
        $this->m_CounterName    = "kc_counter";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function CounterTemplate()
    {        
        $this->SetTemplate("CounterStatic.ihtml");
        $this->SetBlock("row", "rows");
        $this->SetBlock("total_static", "ttotal_static");
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetWebParameter()
    {
        global $HTTP_GET_VARS;
        switch($HTTP_GET_VARS["csf"])
        {
            case $this->COUNT_STATIC_YEAR:
            case $this->COUNT_STATIC_MONTH:
            case $this->COUNT_STATIC_DAY:
            case $this->COUNT_STATIC_HOUR:
            case $this->COUNT_STATIC_WEEK:
            case $this->COUNT_STATIC_TOTAL:
                $this->m_CountStatic = $HTTP_GET_VARS["csf"];
                break;
            default:
                $this->m_CountStatic = $this->COUNT_STATIC_TOTAL;
                break;
        }
       
        $this->m_StaticDate = $HTTP_GET_VARS["sd"];
        $DateInfo = split('-', $this->m_StaticDate);
        if(count($DateInfo) == 3)
        {
            $this->m_StaticDateYear  = $DateInfo[0];
            $this->m_StaticDateMonth = $DateInfo[1];
            $this->m_StaticDateDay   = $DateInfo[2];
        }
        else
        {
            $this->m_StaticDate      = date("Y-m-d");
            $this->m_StaticDateYear  = date("Y");
            $this->m_StaticDateMonth = date("m");
            $this->m_StaticDateDay   = date("d");
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->SetStaticDateInfo();
        // ü  ڷ 
        if($this->m_CountStatic == $this->COUNT_STATIC_TOTAL)
        {
            $this->SetGeneralStatic();
        }
        // Ⱓ  ڷ 
        else
        {            
            $this->CounterStaticList();            
        }        
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */    
    function SetLastData()
    {
        $this->m_Template->set_var(array(
        "STATIC_TOTAL_COUNT" => $this->m_StaticTotalCount,
        "STATIC_TITLE"       => $this->m_StaticTitle
        ));
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetUIValue()
    {
        $this->m_Template->set_var(array(
            "COUNT_STATIC_FORMAT" => $this->m_CountStatic,
            "STATIC_DATE"         => $this->m_StaticDate,
            "STATIC_DATE_YEAR"    => $this->m_StaticDateYear,
            "STATIC_DATE_MONTH"   => $this->m_StaticDateMonth,
            "STATIC_DATE_DAY"     => $this->m_StaticDateDay
        ));
    }


    /* --------------------------------------------------
     * access : protected
     * ü  ڷ  
     * -------------------------------------------------- */
    function SetGeneralStatic()
    {
        $CounterMng = new KCCounterMng;
        $CounterMng->SetDateFormat("%Y/%m/%d");
        $CounterMng->LoadTodayInfo();
        $this->m_StaticTotalCount = $CounterMng->GetTotalCount();
        $this->m_Template->set_var(array(
            "TODAY_COUNT"        => $CounterMng->GetTodayCount(),
            "START_DATE"         => $CounterMng->GetStartDate(),
            "YESTERDAY_COUNT"    => $CounterMng->GetYesterDayCount(),
            "TOTAL_COUNT"        => $this->m_StaticTotalCount,
            "DAYS_FROM_START"    => $CounterMng->GetDaysFromStart(),
            "AVERAGE_COUNT"      => $CounterMng->GetAverageCount()
        ));
        $this->m_Template->parse("ttotal_static", "total_static");
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetStaticDateInfo()
    {
        switch($this->m_CountStatic)
        {
            case $this->COUNT_STATIC_YEAR:
                // STATIC_YEAR   
                $this->m_DateType = "-1";
                $this->m_OuterJoinDateFormat = "-1";
                $this->m_TotalStaticFormat   = "-1";
                $this->m_StaticTitle = "⵵";
                break;

            case $this->COUNT_STATIC_MONTH:
                $this->m_DateType = "0";
                $this->m_OuterJoinDateFormat = "CONCAT('". $this->m_StaticDateYear. "', KBD.Date) = DATE_FORMAT(KC.LogDate ,  '%Y%m')";
                $this->m_TotalStaticFormat   = "%Y";
                $this->m_StaticTitle = "";
                break;

            case $this->COUNT_STATIC_DAY:
                $this->m_DateType = "1";
                $this->m_OuterJoinDateFormat = "CONCAT('". $this->m_StaticDateYear. $this->m_StaticDateMonth ."', KBD.Date) = DATE_FORMAT(KC.LogDate ,  '%Y%m%d')";
                $this->m_TotalStaticFormat   = "%Y%m";
                $this->m_StaticTitle = "Ϻ";
                break;

            case $this->COUNT_STATIC_HOUR:       
                $this->m_DateType = "2";
                $this->m_OuterJoinDateFormat = "CONCAT('". $this->m_StaticDateYear. $this->m_StaticDateMonth . $this->m_StaticDateDay."', KBD.Date) = DATE_FORMAT(KC.LogDate ,  '%Y%m%d%H')";
                $this->m_TotalStaticFormat   = "%Y%m%d";
                $this->m_StaticTitle = "ð";
                break;
            case $this->COUNT_STATIC_WEEK:
                $this->m_DateType = "3";                
                $this->m_OuterJoinDateFormat =   "CONCAT(DATE_FORMAT('" . $this->m_StaticDate. "', '%V'), KBD.Date) =  DATE_FORMAT(KC.LogDate ,  '%V%w')";
                $this->m_TotalStaticFormat   = "%Y%m%V";
                $this->m_StaticTitle = "ְ";
                break;            
            case $this->COUNT_STATIC_TOTAL:
            default :                
                $this->m_DateType = "";
                $this->m_StaticTitle = "ü";
                break;
        }                      
        return $Ret;
    }
   
   
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function LoadStaticTotalCount()
    {
        $this->m_StaticTotalCount = "0";
        $DbMan = new KCDbSql;
        
        // ü ڷ 
        if($this->m_CountStatic == $this->COUNT_STATIC_YEAR)
        {
            $Query = "SELECT SUM(KC.Count) as TotalCount FROM `$this->m_CounterName` as KC  ";
        }
        // Ⱓ ڷ 
        else
        {
            $Query = "SELECT SUM(KC.Count) as TotalCount FROM `$this->m_CounterName` as KC  WHERE DATE_FORMAT('". $this->m_StaticDate ."', '". $this->m_TotalStaticFormat ."') = DATE_FORMAT(KC.LogDate, '". $this->m_TotalStaticFormat ."') ";
        }        
        $Result = $DbMan->query($Query);
        if($Result)
        {
            if($DbMan->next_record())
            {
                $this->m_StaticTotalCount = $DbMan->f("TotalCount");
            }
        }
        $this->m_StaticTotalCount;
    }
    
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */    
    function GetBarWidth($Count)
    {
        $Ret = 0 ;
        if($this->m_StaticTotalCount != 0)
        {
            $Ret = ($Count * $this->STATIC_MAX_LENGTH ) / $this->m_StaticTotalCount ;
        }                             
        return round($Ret);   
    }
    
    
    /* --------------------------------------------------
     * access :
     * 
     * -------------------------------------------------- */    
    function GetPercentage($Count)
    {
        $Ret = 0 ;
        if($this->m_StaticTotalCount != 0)
        {
            $Ret = ($Count * 100 ) / $this->m_StaticTotalCount ;
        }                             
        return round($Ret, 1);           
    }
    
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CounterStaticList()
    {
        $this->LoadStaticTotalCount();
        $DbMan = new KCDbSql;
        $SqlClause = new KCSqlClause();
        
        // ⺰ 
        if($this->m_CountStatic ==  $this->COUNT_STATIC_YEAR)
        {
            $SqlClause->SetTable("`$this->m_CounterName` KC");            
            $SqlClause->SetField("SUM(KC.Count) as Count, DATE_FORMAT(KC.LogDate, '%Y') as StaticDate, DATE_FORMAT(KC.LogDate, '%Y') as DateName");
        }
        // ׿  
        else
        {
            $SqlClause->SetTable("kc_baseDate KBD LEFT OUTER JOIN `$this->m_CounterName` KC ON ". $this->m_OuterJoinDateFormat . " ");
            $SqlClause->SetField("SUM(KC.Count) as Count , KBD.Date as StaticDate, KBD.DateName as DateName");            
            $SqlClause->SetWhere("KBD.DateType = ". $this->m_DateType);
        }
        $SqlClause->SetGroupBy("GROUP BY StaticDate, DateName ");
        $SqlClause->SetOrder(" ORDER BY StaticDate ASC ");
        $Result = $DbMan->query($SqlClause->GetQuery());
        if($Result)
        {
            if($DbMan->nf() > 0)
            {
                $StartNum     = $SqlClause->GetStartListNum();
                while($DbMan->next_record())
                {
                    $this->m_Template->set_var( array(
                        "NUMBER"       => $StartNum,
                        "COUNT"        => $DbMan->f("Count"),
                        "FULLLOGDATE"  => urlencode($DbMan->f("FullLogDate")),
                        "DATENAME"     => $DbMan->f("DateName"),
                        "BARWIDTH"     => $this->GetBarWidth($DbMan->f("Count")),
                        "PERCENTAGE"   => $this->GetPercentage($DbMan->f("Count"))
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $StartNum -- ;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));
    }
}
    $CounterStatic = new KCCounterStatic;
    $CounterStatic->PageLoad();
    $CounterStatic->LoadTemplate();
?>