<?
/*
 ************************************************************************
 * File Name   : UserList.php
 * Class Name  : KCUserList
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("ADMINENV"))       require("../AdminEnv.php");
if(!defined("KCADMINUI"))      require(ADMIN_CLASS . "/KCAdminUI.php");
if(!defined("KCSQLCLAUSE"))    require(K_LIB_PATH . "/KCSqlClause.php");
if(!defined("KCTEXTBOX"))      require(K_LIB_PATH . "/KCTextBox.php");
if(!defined("KCUSERSEARCHSB")) require(ADMIN_CLASS . "/KCUserSearchSB.php");
if(!defined("KCUSERINFO"))     require(K_KLOCLASS_PATH. "/KCUserInfo.php");

define("KCUSERLIST", true);
class KCUserList extends KCAdminUI
{
    var $m_SearchWord;
    var $m_SearchField;
    var $m_SearchFlag;
    var $m_OrderFlag;
    var $m_SortField;
    var $m_SortOrder;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCUserList()
    {
        $this->KCAdminUI();
        $this->m_SearchFlag = false;
        $this->m_OrderFlag  = false;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function AdminTemplate()
    {        
        $this->SetTemplate("UserList.ihtml");
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetAdminUIValue()
    {
        $SearchWord  = new KCTextBox("sw");
        $SearchField = new KCUserSearchSB("sf");
        $SearchWord->SetValue($this->m_SearchWord);
        $SearchField->LoadData();
        $this->m_Template->set_var(array(
            "SEARCHFIELD" => $SearchField->SBBind($this->m_SearchField),
            "SEARCHWORD"  => $SearchWord->GetValue()
        ));
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_SearchWord  = $HTTP_GET_VARS["sw"];
        $this->m_SearchField = $HTTP_GET_VARS["sf"];

        $this->m_SortField  = $HTTP_GET_VARS["sf"];
        $this->m_SortOrder   = $HTTP_GET_VARS["so"];

        //Search 
        if($this->m_SearchWord != "")
        {
            $this->m_SearchFlag = true;
        }

        //Sort 
        if($this->m_SortField)
        {
            $this->m_OrderFlag = true;
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->UserList();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UserList()
    {
        $DbMan = new KCDbSql;
        $SqlClause = new KCSqlClause();
        $SqlClause->SetTable("kb_userinfo KUI");
        $SqlClause->SetField("KUI.*, DATE_FORMAT(KUI.RegDate,'%Y-%m-%d') as SRegDate");        

        if($this->m_OrderFlag)
        {
            $SqlClause->SetOrder("ORDER BY $this->m_SortField $this->m_SortOrder");
        }
        else
        {
            $SqlClause->SetOrder("ORDER BY RegDate DESC");
        }


        //˻ Query  ֱ
        if($this->m_SearchFlag)
        {
            $FieldFlag = true;
            $Query = "";
            switch($this->m_SearchField)
            {
                case "UserId":
                case "Name":
                    $Query = "$this->m_SearchField like '%$this->m_SearchWord%' ";
                    break;            }
            $SqlClause->SetWhere($Query);
        }

        //$SqlClause->SetOrder(" ORDER BY TopOrder desc, Ref desc, ReLevel ");
        $Result = $DbMan->query($SqlClause->GetListQuery(15));
        if($Result)
        {
            if($DbMan->nf() > 0)
            {
                $RowCount = 0;
                $StartNum     = $SqlClause->GetStartListNum();
                while($DbMan->next_record())
                {
                    $TdAttr = "";

                    if(($RowCount % 2) == 1)
                    {
                        $TdAttr = "bgcolor=\"#F2F2EE\"";
                    }
                    
                    if($DbMan->f("IsAdmin") == "T")
                    {
                        $Disabled = "disabled";
                    }
                    else
                    {
                        $Disabled = "";
                    }
                    
                    //   
                    if($DbMan->f("EMail") == "@" || $DbMan->f("EMail") == "")
                    {
                        $EMail = "#";                        
                    }
                    else
                    {
                        $EMail = "mailto:". $DbMan->f("Name") ."<". $DbMan->f("EMail") .">";                        
                    }
                    
                    if($DbMan->f("Homepage") != "")
                    {
                        $Homepage = $DbMan->f("Homepage");
                        $Target   = "kbhomepage";
                    }
                    else
                    {
                        $Homepage = "#";
                        $Target   = "_self";                        
                    }
                    
                    
                    $this->m_Template->set_var( array(
                        "NUMBER"     => $StartNum,
                        "USERID"     => $DbMan->f("UserId"),
                        "NAME"       => $DbMan->f("Name"),
                        "EMAIL"      => $EMail,
                        "HOMEPAGE"   => $Homepage,
                        "TARGET"     => $Target,
                        "USERTYPE"   => $DbMan->f("UserTypeName"),
                        "JUMIN"      => $DbMan->f("Jumin"),
                        "LOGINCOUNT" => $DbMan->f("LoginCount"),
                        "USEFLAG"    => $DbMan->f("UseFlag"),
                        "LOGINTIME"  => $DbMan->f("LoginTime"),
                        "LOGOUTTIME" => $DbMan->f("LogoutTime"),
                        "USERLEVEL"  => $DbMan->f("UserLevel"),
                        "REGDATE"    => $DbMan->f("SRegDate"),
                        "DISABLED"   => $Disabled,
                        "TDATTR"     => $TdAttr

                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $StartNum -- ;
                    $RowCount ++;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpldateUserFlag()
    {
        global $HTTP_POST_VARS;
        $UserInfo = new KCUserInfo;
        if($UserInfo->UpdateUseFlag($HTTP_POST_VARS["UserId"], $HTTP_POST_VARS["updatevalue"]))
        {
            $this->GoCurrentPage();
        }
        else
        {
            $this->PrintError(" Flag Ʈ Դϴ.");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpldateUserLevel()
    {
        global $HTTP_POST_VARS;
        $UserInfo = new KCUserInfo;
        if($UserInfo->UpdateUserLevel($HTTP_POST_VARS["UserId"], $HTTP_POST_VARS["updatevalue"]))
        {
            $this->GoCurrentPage();
        }
        else
        {
            $this->PrintError(" UserLevel   ");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function DeleteUser()
    {
        global $HTTP_POST_VARS;
        $UserInfo = new KCUserInfo;
        if($UserInfo->DeleteData($HTTP_POST_VARS["UserId"]))
        {
            $this->GoCurrentPage();
        }
        else
        {
            $this->PrintError("  ");
        }
    }
}

    $UserList = new KCUserList;
    $UserList->PageLoad();
    $UserList->LoadTemplate();
?>
