<?
/*
 ************************************************************************
 * File Name   : KCCounter.php
 * Class Name  : KCCounter
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCCOUNTER", true);
class KCCounter extends KCDataBase
{
    var $m_Id;
    var $m_Count;
    var $m_LogDate;
    var $m_LogDateFormat;
    var $m_CounterTableName ;
    
    
    var $m_StartDate ;
    var $m_DaysFromStart;
    var $m_TotalCount;
    var $m_YesterdayCount;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCounter($TableName = "kc_counter")
    {
        $this->KCDataBase();
        $this->m_LogDateFormat    = "%Y/%m/%d";
        $this->m_CounterTableName = $TableName;
        $this->m_StartDate        = false;
        $this->m_DaysFromStart    = false;
        $this->m_TotalCount       = false;
        $this->m_YesterdayCount   = false;
    }


    /* --------------------------------------------------
     * access : public 
     *
     * -------------------------------------------------- */
    function GetStartDate()
    {
        if($this->m_StartDate == false)
        {
            $this->m_StartDate = "0";
            $Query = "SELECT DATE_FORMAT(LogDate, '$this->m_LogDateFormat') as LogDate FROM `$this->m_CounterTableName` ORDER BY LogDate ASC LIMIT 0, 1 ";
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_StartDate = $this->m_DbMan->f("LogDate");
                }
            }
        }
        return $this->m_StartDate;
    }         
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function IncreaseCount()
    {
        $Query = "UPDATE `$this->m_CounterTableName` SET Count = Count + 1 WHERE DATE_FORMAT(LogDate, '%y%m%d%H') = DATE_FORMAT(now(), '%y%m%d%H') ";
        if(!$this->AffectOperate($Query))
        {
            $Query = "INSERT INTO `$this->m_CounterTableName`(Count, LogDate) VALUES('1', now())";
            return $this->ExecuteQuery($Query);
        }
    }
    
    
    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function LoadTodayCountInfo()
    {   
        
        $Query = "SELECT SUM(Count) AS Count , DATE_FORMAT(LogDate, '$this->m_LogDateFormat') as CountDate  FROM `$this->m_CounterTableName` WHERE DATE_FORMAT(LogDate, '%y%m%d') = DATE_FORMAT(now(), '%y%m%d') GROUP BY CountDate ";        
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $this->m_Count   = $this->m_DbMan->f("Count");
                $this->m_LogDate = $this->m_DbMan->f("CountDate");;                                
            }
            // Counte    Count 0  ¥ ȯѴ.
            else
            {
                $this->m_Count   = "0";
                $this->m_LogDate = date(str_replace("%", "", $this->m_LogDateFormat));
            }
        }
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetTotalCount()
    {
        if($this->m_TotalCount == false)
        {
            $this->m_TotalCount = "0";
            $Query = "SELECT SUM(Count) as Count FROM $this->m_CounterTableName ";        
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_TotalCount = $this->m_DbMan->f("Count");
                }
            }
        }
        return $this->m_TotalCount;

    }
    
    
    /* --------------------------------------------------
     * access : 
     * 
     * -------------------------------------------------- */    
    function GetYesterDayCount()
    {
        if($this->m_YesterdayCount == false)
        {
            $Query = "SELECT Count FROM `$this->m_CounterTableName` WHERE DATE_FORMAT(LogDate, '%y%m%d') = DATE_FORMAT(SUBDATE(now(),INTERVAL 1 DAY), '%y%m%d')";                
            if($this->m_DbMan->query($Query))
            {
                $this->m_YesterdayCount = "0";
                if($this->m_DbMan->next_record())
                {
                    $this->m_YesterdayCount = $this->m_DbMan->f("Count");
                }
            }
        }        
        return $this->m_YesterdayCount;
    }
    
    
    /* --------------------------------------------------
     * access : 
     * Ϸκ   ¥  ȯմϴ. 
     * -------------------------------------------------- */
    function GetDaysFromStart()
    {
        if($this->m_DaysFromStart == false)
        {
            $this->m_DaysFromStart = "0";
            $Query = "SELECT TO_DAYS(now()) - TO_DAYS('$this->m_StartDate') as Days";
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_DaysFromStart = $this->m_DbMan->f("Days");
                }
            }
        }
        return $this->m_DaysFromStart;
    }
    
    
    /* --------------------------------------------------
     * access : 
     * ü Ⱓ ü īͷ  ī͸ ȯ
     * -------------------------------------------------- */
    function GetAverageCount()
    {
        $TotalCount = $this->GetTotalCount();
        $TotalDays  = $this->GetDaysFromStart();
        
        $Ret = 0 ;
        if($TotalDays != 0)
        {
            $Ret = round($TotalCount / $TotalDays);                        
        }
        return $Ret ;
    }
}
?>