<?
/*
 ************************************************************************
 * File Name   : Register.php
 * Class Name  : KCRegister
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("USERREGENV"))    require("../KUserRegEnv.php");
if(!defined("KCREGISTERUI"))  require(USERREG_CLASS . "/KCRegisterUI.php");
if(!defined("KCTEXTBOX"))     require(K_LIB_PATH .    "/KCTextBox.php");
if(!defined("KCPASSWORDBOX")) require(K_LIB_PATH .    "/KCPasswordBox.php");
if(!defined("KCCHECKBOX"))    require(K_LIB_PATH .    "/KCCheckBox.php");
if(!defined("KCUSERINFO"))    require(K_KLOCLASS_PATH.   "/KCUserInfo.php");
if(!defined("KCKAUTH"))       require(K_KLOCLASS_PATH.   "/KCKAuth.php");
if(!defined("KCVALIDATE"))    require(K_LIB_PATH .    "/KCValidate.php");

define("KCREGISTER", true);
class KCRegister extends KCRegisterUI
{
    var $m_UserId;
    var $m_Passwd;
    var $m_Name;
    var $m_EMail1;
    var $m_EMail2;
    var $m_Homepage;
    var $m_ValidateMail;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCRegister()
    {
        $this->KCRegisterUI();
        $this->m_UserId         = new KCTextBox("UserId");
        $this->m_Passwd         = new KCPasswordBox("Passwd");
        $this->m_Name           = new KCTextBox("Name");
        $this->m_EMail1         = new KCTextBox("EMail1");
        $this->m_EMail2         = new KCTextBox("EMail2");
        $this->m_Homepage       = new KCTextBox("Homepage");
        $this->m_ValidateMail   = new KCValidate("ValidateMail");        
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        // ̺Ʈ μ ƴϰ
        if(!$this->m_Cmd)
        {
            //  α  Ǿ 
            if(!$this->IsAuth())
            {
                ;
            }
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartRegisterTemplate()
    {
        $this->SetTemplate("Register.ihtml");
        $this->SetBlock("loginend", "tloginend");
        $this->SetBlock("checkuserid", "tcheckuserid");

    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        if($this->IsAuth())
        {
            $this->LoadUserInfo();
        }
        else
        {
            $this->SetUserInfo();
        }
        $this->DefaultBoardValue();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadUserInfo()
    {
        $UserInfo = new KCUserInfo;
        if($UserInfo->LoadData($this->m_Auth->GetUserId()))
        {
            $this->m_UserId->SetValue($UserInfo->m_UserId);
            $this->m_Name->SetValue($UserInfo->m_Name);
            $this->m_EMail1->SetValue($UserInfo->GetEMail(0));
            $this->m_EMail2->SetValue($UserInfo->GetEMail(1));
            $this->m_Homepage ->SetValue($UserInfo->m_Homepage);
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetUserInfo()
    {
        global $HTTP_POST_VARS;
        $this->m_Name->SetValue($HTTP_POST_VARS["Name"]);
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function SetRegisterUIValue()
    {
        // ȸ  
        if($this->IsAuth())
        {
            $this->m_Template->set_var(array(
                    COMMAND         => "UpdateUserInfo",
                    REG_CHEC_FUNC   => "UCheckInput",
                    UPDATE_READONLY => "readonly",
                    REG_TITLE       => "tp_tit_modify.gif",
                    SUBMITBTN       => "btn_modify.gif",
                    ));
        }
        // ȸ 
        else
        {
            $this->m_Template->set_var(array(
                    COMMAND        => "InsertUserInfo",
                    REG_CHEC_FUNC  => "RCheckInput",
                    tcheckuserid   => $this->m_Template->get_var("checkuserid"),
                    REG_TITLE      => "tp_tit.gif",
                    SUBMITBTN      => "ok.gif",
                    ));
        }
        $this->m_ValidateMail->m_Controltovalidate = "CheckEMail";
        $this->m_ValidateMail->m_ErrorMessage = "߸  ּ Դϴ.";
        $this->m_ValidateMail->m_EvaluationFunction = "RegularExpressionValidatorEvaluateIsValid";
        $this->m_ValidateMail->m_ValidationExpression = $this->m_ValidateMail->REG_EXPRESS_MAIL;
        $this->m_Template->set_var("VALIDATEMAIL", $this->m_ValidateMail->GetTag());
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSexCheck($Value)
    {
        if($this->m_Sex == $Value)
        {
            return "checked";
        }
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function DefaultBoardValue()
    {
        $this->m_Template->set_var(array(
            "USERID"         => $this->m_UserId->GetValue(),
            "PASSWD"         => $this->m_Passwd->GetInputBox(),
            "NAME"           => $this->m_Name->GetValue(),
            "EMAIL1"         => $this->m_EMail1->GetValue(),
            "EMAIL2"         => $this->m_EMail2->GetValue(),
            "HOMEPAGE"       => $this->m_Homepage->GetValue()
        ));
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpdateUserInfo()
    {
        global $HTTP_POST_VARS;
        $UserInfo = new KCUserInfo;
        $UserInfo->SetDataValue($HTTP_POST_VARS);
        if(!$UserInfo->UpdateData($HTTP_POST_VARS["UserId"]))
        {
            $this->m_JSUtil->AlertBack("    ߻߽ϴ.");
        }
        else
        {
            $this->m_JSUtil->Alert("Ǿϴ.");
            echo $this->m_Template->get_var("loginend");
        }
        exit;
    }


    /* --------------------------------------------------
     * access : protected
     *   Ŀ α 
     * -------------------------------------------------- */
    function Login($UserId, $Password, $UserType)
    {
        $Auth = new KCKAuth;
        $Auth->Login($UserId, $Password, $UserType);
        echo $this->m_Template->get_var("loginend");
        exit;

    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function InsertUserInfo()
    {
        //phpinfo();
        //exit;
        global $HTTP_POST_VARS;       
        $UserInfo = new KCUserInfo;
        $UserInfo->SetDataValue($HTTP_POST_VARS);
        if($UserInfo->IsExistUserId($HTTP_POST_VARS["UserId"]))
        {
            $this->m_JSUtil->AlertBack("ϴ ̵ Դϴ. ٸ ̵ ֽʽÿ");
        }
        else
        {
            if(!$UserInfo->InsertData())
            {
                $this->m_JSUtil->AlertBack("Է  ߻߽ϴ.");
            }
            else
            {
                $this->Login($HTTP_POST_VARS["UserId"], $HTTP_POST_VARS["Passwd"], $HTTP_POST_VARS["UserType"]);
            }
        }
    }
}
    $Register = new KCRegister;
    $Register->PageLoad();
    $Register->LoadTemplate();
?>