<?
/*
 ************************************************************************
 * File Name   : InstallKB.php
 * Class Name  : KCInstallKB
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("K_LIB_ENV"))   require("../kEnv.php");
if(!defined("KCINSTALLUI")) require( "./KCInstallUI.php");
if(!defined("KCDATABASE"))  require(K_LIB_PATH      . "/KCDataBase.php");
if(!defined("KCUSERINFO"))  require(K_KLOCLASS_PATH . "/KCUserInfo.php");

define("KCINSTALLKB", true);
class KCInstallKB extends KCInstallUI
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCInstallKB()
    {
        $this->KCInstallUI();
    }

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetTemplate("InstallKB.ihtml");
        $this->SetBlock("insert_admin", "tinsert_admin");
        $this->SetBlock("create_table", "tcreate_table");        
        $this->SetBlock("exist_admin", "texist_admin");        
        $this->SetBlock("complete", "tcomplete");        
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        $DbMan = new KCDataBase;        
        if(!$DbMan->IsExistTable("kb_boardmanager"))
        {
            $this->m_Template->parse("tcreate_table", "create_table");
        }        
        else
        {
            $UserInfo = new KCUserInfo;
            if($UserInfo->IsExistAdmin())
            {
                $this->m_Template->parse("texist_admin", "exist_admin");                
                $this->m_Template->parse("tcomplete", "complete");                
            }
            else
            {
                $this->m_Template->parse("tinsert_admin", "insert_admin");                
            }
        }
    }
    
    /* --------------------------------------------------
     * access : protected
     * event function
     * -------------------------------------------------- */    
    function InstallEnv()
    {
        $this->ChmodUpload();        
        $this->CreateKBTable();
    }    
    
    
    /* --------------------------------------------------
     * access : private
     * upload 丮  Ѵ.
     * -------------------------------------------------- */        
    function ChmodUpload()
    {
        chmod(KBOARD_BOARD ."/upload", 0707); 
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * -------------------------------------------------- */    
    function CreateKBTable()
    {
        $this->ChmodUpload();
        $DbMan = new KCDataBase;
        
        if(!$DbMan->IsExistTable("kb_boardmanager"))
        {
            $filename = "create_table.sql";
            $handle = fopen ($filename, "r");
            $CreateSQL = fread ($handle, filesize ($filename));
            fclose ($handle);        
            $CreateSQL = trim($CreateSQL);
            $SQLs = split(";", $CreateSQL);
            foreach($SQLs as $ExecuteSQL)
            {
                if(!empty($ExecuteSQL))
                {
                    $Ret = $DbMan->ExecuteQuery($ExecuteSQL);
                }
            }                    
            $this->GoCurrentPage();
        }
        else
        {
            
        }
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * event function 
     * -------------------------------------------------- */        
    function InsertAdmin()
    {
        global $HTTP_POST_VARS;
        $UniqueId = md5(time());        
        $UserId = $HTTP_POST_VARS["UserId"];
        $Passwd = $HTTP_POST_VARS["Passwd"];
        $Name   = $HTTP_POST_VARS["Name"];
        
        $Query = "INSERT INTO kb_userinfo(UserId, Passwd, Name, RegDate, UniqueId, UserLevel, IsAdmin)
                    VALUES('$UserId', PASSWORD('$Passwd'),  '$Name', now(), '$UniqueId', '1', 'T') ";
        $DbMan = new KCDataBase;
        if($DbMan->ExecuteQuery($Query))
        {
            $this->GoCurrentPage();                        
        }
    }
}

    $InstallKB = new KCInstallKB;
    $InstallKB->PageLoad();
    $InstallKB->LoadTemplate();
?>