<?
/*
 ************************************************************************
 * File Name   : KCBoardTopList.php
 * Class Name  : KCBoardTopList
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 22
 ************************************************************************
 */


if(!defined("KBOARDENV"))        require("../KBoardEnv.php");
if(!defined("KCBOARDUI"))        require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCBOARDSQLCLAUSE")) require(KBOARD_CLASS . "/KCBoardSqlClause.php");
if(!defined("KCBOARDSEARCHSB"))  require(KBOARD_CLASS . "/KCBoardSearchSB.php");
if(!defined("KCTEXTBOX"))        require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCSTRING"))         require(K_LIB_PATH   . "/KCString.php");
if(!defined("KCCATEGORYSB"))     require(KBOARD_CLASS . "/KCCategorySB.php");
if(!defined("KCBOARD"))          require(KBOARD_CLASS . "/KCBoard.php");

define("KCBOARDLIST", true);
class KCBoardList extends KCBoardUI
{
    var $m_SubjectLength ;
    var $m_Category;
    var $m_FetchListNum;    // Select ÿ µ List  
    var $m_StartNum;        // List µǴ ȣ 
    var $m_TotalRowNum;     // Fetch  Count 
    var $m_SelectedId;      //  ⿡    ִ  
    
    var $m_IsListAtLeastOneTime = false;
    var $SCOPE_VALUE_TOPORDER   = 0; //  TopOrder    Scope 
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardList($SelectedId = null)
    {
        $this->KCBoardUI();
        $this->m_ViewTitleImage = false;
        $this->m_SubjectLength  = 47;
        $this->m_Category       = new KCCategorySB("Category");
        $this->m_StartNum       = null;
        $this->m_SelectedId     = $SelectedId;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        $this->SetTemplate($this->m_BoardManager->m_TplList);
        $this->SetBlock("category", "tcategory");
        $this->SetBlock("tit_delete", "ttit_delete");
        $this->SetBlock("check_delete", "tcheck_delete");
        $this->SetBlock("btn_delete", "tbtn_delete");        
        $this->SetBlock("tit_upload", "ttit_upload");
        $this->SetBlock("list_upload", "tlist_upload");
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");              
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        $this->CheckPagePerm($this->m_BoardManager->m_AuthList)
        ;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {        
        // Table Idx   
        if($this->m_TableIdx != "")
        {
            $this->m_Template->set_var("TABLEID", $this->m_TableIdx);
        }
        
        // Category  ߰ 
        if($this->m_BoardManager->m_UseCategory == "T")
        {
            $this->m_Template->parse("tcategory", "category");
            $this->m_Category->SetAttribute("onchange", "SelectCategory(this)");
            $this->m_Category->LoadData($this->m_BoardTable);
            $Category = $this->m_Category->SBBind($this->m_CategoryValue);           
        }
        //   ߰ 
        if($this->IsAdmin())
        {
            $this->m_Template->parse("ttit_delete", "tit_delete");
            $this->m_Template->parse("tcheck_delete", "check_delete");
            $this->m_Template->parse("tbtn_delete", "btn_delete");
        }
        
        // Upload  ߰ 
        if($this->m_BoardManager->m_MaxUpload > 0)
        {
            $this->m_Template->parse("ttit_upload", "tit_upload");
            $this->m_Template->parse("tlist_upload", "list_upload");
        }
        
        
        // Default  ߰ 
        $this->m_Template->set_var(array(
            TABLENAME        => $this->m_BoardTable,
            SEARCH_SELECTBOX => $this->LoadSearchForm(),
            SEARCH_VALUE     => $this->LoadSearchText(),
            CATEGORYSB       => $Category,
            CATEGORYVALUE    => $this->m_CategoryValue
        ));
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->InitBoardList();        
        $this->BoardList();
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadSearchForm()
    {
        $SearchSB = new KCBoardSearchSB("sf");
        $SearchSB->SetAttribute("style", "width:70;");
        $SearchSB->LoadData();
        return $SearchSB->SBBind($this->m_SearchField);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadSearchText()
    {
        $SearchText = new KCTextBox("sw",$this->m_SearchWord);
        $SearchText->SetAttribute("class", "forms");
        $SearchText->SetAttribute("style", "width:120px;");
        return $SearchText->GetValue();
    }


    /* --------------------------------------------------
     * access :
     * step ̿Ͽ  Ʈ    Ʈ 
     * -------------------------------------------------- */
    function  GetSubjectSpace($Step)
    {
        for($i = 0 ; $i < $Step ;$i ++)
        {
            $Space .="&nbsp;&nbsp;";
        }
        if($Step > 0)
        {
            $Space .= "<img src='" . $this->GetSkinPath() . "/images/reply_icon.gif'> ";
        }
        return $Space ;
    }


    /* --------------------------------------------------
     * access : private 
     * BoardList   ʱȭ Ѵ. 
     * -------------------------------------------------- */
    function InitBoardList()
    {
        $this->m_FetchListNum = $this->m_BoardManager->m_ListPerPage;
        $this->m_TotalRowNum  = null;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function BoardList()
    {
        $DbMan     = new KCDbSql;
        $SqlClause = new KCBoardSqlClause($this->m_BoardTable, $this->m_Scope, $this->m_TotalRowNum);
        
        //$SqlClause->SetTable(" `$this->m_BoardTable` as BT  USE KEY (CategorySort) " );
        $SqlClause->SetTable(" `$this->m_BoardTable` as BT " );
        $SqlClause->SetUseKey("SortIndex");
        $SqlClause->SetField("BT.Id, BT.Name, BT.EMail, BT.Subject, BT.Step,  UNIX_TIMESTAMP(BT.Wdate) as Wdate, BT.Hit, BT.TopOrder, BT.Category, BT.Pds, BT.Comment as CommentCount, Scope");

     

        //˻ Query  ֱ
        if($this->m_SearchFlag)
        {                         
            $SqlClause->SetSearchFlag(true);
            $FieldFlag = true;
            $EqualOperator  = false;
            switch(strtolower($this->m_SearchField))
            {
                //񿡼 ã
                case $this->SEARCH_FIELD_SUBJECT:
                    $FieldName = "Subject";
                    break;
                //뿡 ã
                case $this->SEARCH_FIELD_CONTENTS:
                    $FieldName = "Contents";
                    break;
                //ۼڿ ã
                case $this->SEARCH_FIELD_NAME:
                    $FieldName = "Name";
                    break;
                default :
                    $FieldFlag = false;
            }
            if($FieldFlag)
            {
                if($EqualOperator)
                {
                    $SqlClause->SetWhere("BT.$FieldName = '$this->m_SearchWord%' ");
                }
                else
                {
                    $SqlClause->SetWhere("BT.$FieldName like '%$this->m_SearchWord%' ");
                }
            }
        }
        
        //Category ˻ ߰ 
        if($this->m_CategoryFlag == true )
        {           
            
            $SqlClause->SetSearchFlag(true);
            $SqlClause->SetWhere("BT.Category = '$this->m_CategoryValue' ");                
        }
        
        
        $SqlClause->SetOrder(" ORDER BY TopOrder DESC, Ref DESC, ReLevel DESC ");        
        $Query = $SqlClause->GetListQuery($this->m_FetchListNum);
        //$this->SetBoardList($SqlClause);
        $Result = $DbMan->query($Query);        
        if($Result)
        {   
            if($DbMan->nf() > 0)
            {                
                $this->m_IsListAtLeastOneTime = true;
                $String       = new KCString;
                $DefaultParam = $this->m_PageManager->GetHiddenParam();
                $this->SetStartNum($SqlClause->GetStartListNum());
                
                $ListNumber   = 0;
                while($DbMan->next_record())
                {                    
                    $TdAttr = "";
                    if(($this->m_StartNum % 2) == 1)
                        $TdAttr = "bgcolor=\"#F2F2EE\"";

                    $TopStyle = "";
                    if($DbMan->f("TopOrder") > 0)
                    {
                        $TopStyle = "class=new";
                    }                    

                    // Comment                     
                    if($DbMan->f("CommentCount") != "0" )
                    {                        
                        $CommentCount = "[" . $DbMan->f("CommentCount") . "]";                        
                    }
                    else
                    {
                        $CommentCount = "";                        
                    }                 
                    
                    //   ִ ˻Ѵ.
                    if($this->m_SelectedId != null)
                    {
                        if($this->m_SelectedId == $DbMan->f("Id"))
                        {
                            $Number = "<img src=".$this->GetSkinPath()."/images/kb_SelectedArticleInView.gif border=0>"; 
                        }
                        else
                        {
                            $Number = $this->m_StartNum;
                        }                        
                    }
                    else
                    {
                        $Number = $this->m_StartNum;                        
                    }
                    
                    $ReSpace = $this->GetSubjectSpace($DbMan->f("Step"));
                    $this->m_Template->set_var( array(
                        NUMBER   => $Number,
                        ID       => $DbMan->f("Id"),
                        RESPACE  => $ReSpace,
                        SUBJECT  => $this->MarkSearchWord(" " . $String->GetLimitStr($DbMan->f("Subject"), $this->m_SubjectLength), $this->SEARCH_FIELD_SUBJECT),
                        COMCOUNT => $CommentCount,
                        NAME     => $this->MarkSearchWord($DbMan->f("Name"),    $this->SEARCH_FIELD_NAME),
                        WDATE    => date("m/d", $DbMan->f("Wdate")),
                        PDS      => $DbMan->f("Pds"),
                        HIT      => $DbMan->f("Hit"),
                        TDATTR   => $TdAttr,
                        TOPSTYLE => $TopStyle
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $this->m_StartNum -- ;
                    $ListNumber ++;                    
                    $this->m_FetchListNum --;
                }
            }
            else 
            {
                //ȣ   Ÿ ȣ ʴ´.
                if($this->m_IsListAtLeastOneTime == false)
                    $this->m_Template->parse("rows", "empty", true);
            }


            // ˻   شϴ Scope  ̷ 
            // ˻   ȣ Ʈ ä.
            if($this->IsGoRecursion())
            {
                // Ʈ  ä    ٽ  ȣ 
                //  Scope  
                if($this->m_FetchListNum > 0)
                {
                    $this->m_Scope = $SqlClause->m_Scope;         
                    // TOP ORDER Scope̸ ٽ MaxScope  εѴ.
                    if($this->m_Scope == $this->SCOPE_VALUE_TOPORDER)
                    {
                        $ScopeMng = new KCScope($this->m_BoardTable);
                        $ScopeMng->LoadMaxData();                
                        $this->m_Scope = $ScopeMng->m_Scope;                            
                    }
                    else
                    {
                        $this->m_Scope -- ;
                    }
                    
                    
                    if($this->m_Scope > 0)
                    {
                        
                        $this->m_TotalRowNum = $SqlClause->GetTotalRowNum();
                        $this->BoardList();
                    }                             
                }                    
            }            
        }
        
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));        
    }
 
    
    /* --------------------------------------------------
     * access : private
     * List Start Number մϴ. 
     * -------------------------------------------------- */    
    function SetStartNum($StartNum)
    {
        if($this->m_StartNum == null)        
        {
            $this->m_StartNum = $StartNum;
        }        
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function 
     * -------------------------------------------------- */
    function DeleteRow()
    {
        global $HTTP_POST_VARS;
        if($this->IsAdmin())
        {
            $Board = new KCBoard($this->m_BoardTable);
            $Idxs = $HTTP_POST_VARS["deleteId"];        
            for( $i = 0 ; $i < count($Idxs) ; $i ++)
            {
                if(!$Board->DeleteData($Idxs[$i]))
                {
                    $this->m_JSUtil->AlertBack("   ߻߽ϴ.");
                    break;
                }
            }            
        }
        $this->GoNextPage("BoardList.php");
        exit;
    }
    
    
    /* --------------------------------------------------
     * access : private
     * ȣ  Ѵ.
     * m_SearchFlag ˻ false ̰  
     * m_CategoryFlag    false ϶ 
     * ȣ Ϲ    Ѵ. 
     *   ȣ  ʴ´. 
     * -------------------------------------------------- */    
    function IsGoRecursion()
    {
        return  ($this->m_SearchFlag == false) && ($this->m_CategoryFlag == false) ;
    }
}
?>