<?

/*
 ************************************************************************
 * File Name   : KCCategoryManager.php
 * Class Name  : KCCategoryManager
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    : 
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV")) include("../KBoardEnv.php");

if(!defined("KCBOARDMANAGERUI")) require(KBOARD_CLASS . "/KCBoardManagerUI.php");
if(!defined("KCCATEGORY"))       require(KBOARD_CLASS . "/KCCategory.php");
if(!defined("KCTEXTBOX"))        require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCBUTTON"))         require(K_LIB_PATH   . "/KCButton.php");
if(!defined("KCSEQUENCESB"))     require(K_LIB_PATH   . "/KCSequenceSB.php");

define("KCCATEGORYMANAGER", true);
class KCCategoryManager extends KCBoardManagerUI
{
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function KCCategoryManager()
    {
        $this->KCBoardManagerUI();
    }    
    
    
    /* --------------------------------------------------
     * access : protected
     * override 
     * -------------------------------------------------- */    
    function BoardManagerTemplate()
    {
        $this->SetTemplate("CategoryManager.ihtml");        
        $this->SetBlock();
        $this->SetBlock("empty", "tempty");
        //$this->m_Template->set_var(array("K_JSLIB_PATH" => K_JSLIB_PATH));
    }    
    

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->CategoryManagerList();
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetManagerUIValue()
    {        
        $this->m_Template->set_var("CATEGORY_TABLENAME", $this->m_TableName);        
    }  
        
    
    /* --------------------------------------------------
     * access : private 
     * 
     * -------------------------------------------------- */
    function CategoryManagerList($EditFlag = false, $Idx = "-1")
    {
        $DbMan = new KCDbSql;
        $Query = "SELECT * FROM `" . $this->m_TableName . "_category` ORDER BY categoryOrder ";   
        $Result = $DbMan->query($Query);
        if($Result)
        {   
            $ManagerButton1 = new KCButton();
            $ManagerButton2 = new KCButton();
            $ManagerButton1->SetAttribute("class", "bn");
            $ManagerButton2->SetAttribute("class", "bn");
            $RowCount = 1;
            if($DbMan->nf() > 0)
            {
                while($DbMan->next_record())
                {
                    $Flag = false;
                    if($EditFlag)
                    {
                        if($Idx ==  $DbMan->f("Idx"))
                        {
                            $Flag = true;                        
                        }
                    }
                    
                    $TdAttr = "";
                    if($RowCount % 2 == 0)
                    {
                        $TdAttr = "bgcolor=\"#F2F2EE\"";
                    }
                           


                    if($Flag)
                    {
                        $CategoryOrder = new KCSequenceSB("categoryOrder");
                        $ManagerButton1->SetValue("Ϸ");
                        $ManagerButton2->SetValue("");                    
                        $ManagerButton1->SetAttribute("onclick", "UpdateCategory('" . $DbMan->f("Idx"). "')");                    
                        $ManagerButton2->SetAttribute("onclick", "CancelEdit('" . $DbMan->f("Idx"). "')");
                        $CategoryOrder->LoadData($DbMan->num_rows() - 1);
                        
                        $CategoryName = new KCTextBox("categoryName");                                   
                        $CategoryName->SetValue($DbMan->f("categoryName"));

                        $CategoryNameValue  = $CategoryName->GetInputBox();
                        $CategoryOrderValue = $CategoryOrder->SBBind($DbMan->f("categoryOrder"));
                        $ManageButton1Value = $ManagerButton1->GetInputBox();
                        $ManageButton2Value = $ManagerButton2->GetInputBox();
                    }
                    else
                    {
                        $ManagerButton1->SetValue("");
                        $ManagerButton2->SetValue("");                    
                        $ManagerButton1->SetAttribute("onclick", "EditCategory('" . $DbMan->f("Idx"). "')");                    
                        $ManagerButton2->SetAttribute("onclick", "DeleteCategory('" . $DbMan->f("Idx"). "')");
                        
                        $CategoryNameValue  = $DbMan->f("categoryName");
                        $CategoryOrderValue = $DbMan->f("categoryOrder");
                        $ManageButton1Value = $ManagerButton1->GetInputBox();
                        
                        if($DbMan->f("Idx") != "1")
                        {
                            $ManageButton2Value = $ManagerButton2->GetInputBox();                                                                                    
                        }                        
                        else
                        {
                            $ManageButton2Value = "";                            
                        }
                    }                        
                    
                    
                    $this->m_Template->set_var( array(                 
                        IDX           => $DbMan->f("Idx"),
                        NUMBER        => $RowCount,
                        CATEGORYNAME  => $CategoryNameValue,
                        CATEGORYORDER => $CategoryOrderValue,
                        MANAGEBUTTON1 => $ManageButton1Value,
                        MANAGEBUTTON2 => $ManageButton2Value,
                        TDATTR        => $TdAttr
                        
                    ));                    
                    $RowCount ++;
                    $this->m_Template->parse("rows", "row", true);
                }                
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);                                
            }
        }
        else
        {
            $this->PrintError($DbMan->m_ErrMsg);
            $this->m_JSUtil->AlertBack("īװ  ε  ߻߽ϴ.");
        }
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function
     * -------------------------------------------------- */
    function AddCategory()
    {
        global $HTTP_POST_VARS;        
        $Category = new KCCategory($this->m_TableName);                
        $Category->SetDataValue($HTTP_POST_VARS);
        if(!$Category->InsertData())
        {
            $this->PrintError($Category->m_ErrMsg);
            $this->m_JSUtil->AlertBack("īװ ߰  ߻߽ϴ.");                        
        }
        $this->GoCurrentPage();
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function 
     * -------------------------------------------------- */
    function EditCategory()
    {
        global $HTTP_POST_VARS;
        $this->CategoryManagerList(true, $HTTP_POST_VARS["Idx"]);
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function
     * -------------------------------------------------- */
    function DeleteCategory()
    {
        global $HTTP_POST_VARS;
        $Category = new KCCategory($this->m_TableName);
        if(!$Category->DeleteData($this->m_TableName, $HTTP_POST_VARS["Idx"]))
        {
            $this->PrintError($Category->m_ErrMsg);
            $this->m_JSUtil->AlertBack("īװ   ߻߽ϴ.");            
        }        
        $this->GoCurrentPage();
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function
     * -------------------------------------------------- */
    function UpdateCategory()
    {
        global $HTTP_POST_VARS;
        $Category = new KCCategory($this->m_TableName);
        $Category->SetDataValue($HTTP_POST_VARS);
        if(!$Category->UpdateData($this->m_TableName, $HTTP_POST_VARS["Idx"]))
        {
            if($Category->m_ErrCode == $Category->QUERY_RESULT_ZERO)
            {
                $this->PrintError($Category->m_ErrMsg);
                $this->m_JSUtil->AlertBack("  ϴ.");                                        
            }            
            else
            {
                $this->PrintError($Category->m_ErrMsg);
                $this->m_JSUtil->AlertBack("īװ   ߻߽ϴ.");                                        
            }
        }
        $this->GoCurrentPage();
    }
    
    
    /* --------------------------------------------------
     * access : private
     * event function 
     * -------------------------------------------------- */
    function CancelEdit()
    {
        $this->GoCurrentPage();
    }
}
?>