<?

/*
 ************************************************************************
 * File Name   : KCEditBoardData.php
 * Class Name  : KCEditBoardData
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */

if(!defined("KBOARDENV")) include("../KBoardEnv.php");

if(!defined("KCBOARDMANAGERUI")) require(KBOARD_CLASS . "/KCBoardManagerUI.php");
if(!defined("KCBOARDMANAGER"))   require(KBOARD_CLASS . "/KCBoardManager.php");
if(!defined("KCTEXTBOX"))        require(K_LIB_PATH   . "/KCTextBox.php");
if(!defined("KCFLAGSB"))         require(KBOARD_CLASS . "/KCFlagSB.php");
if(!defined("KCLISTPERPAGESB"))  require(KBOARD_CLASS . "/KCListPerPageSB.php");
if(!defined("KCLIMITSTEPSB"))    require(KBOARD_CLASS . "/KCLimitStepSB.php");
if(!defined("KCUPLOADSB"))       require(KBOARD_CLASS . "/KCUploadSB.php");
if(!defined("KCPERMSB"))         require(KBOARD_CLASS . "/KCPermSB.php");
if(!defined("KCSKINSB"))         require(KBOARD_CLASS . "/KCSkinSB.php");


define("KCEDITBOARDDATA", true);
class KCEditBoardData extends KCBoardManagerUI
{
    var $m_BoardManager ;
    var $m_Description;
    var $m_UseFlag;
    var $m_TplDirectory;
    var $m_TplHeader;
    var $m_TplFooter;
    var $m_TplList;
    var $m_TplView;
    var $m_TplWrite;
    var $m_TplSmplList;
    var $m_ListPerPage;
    var $m_BoardTitle;
    var $m_TitleImage;
    var $m_UseTitleImage;
    var $m_LimitStep;
    var $m_MaxUpload;
    var $m_AuthList;
    var $m_AuthView;
    var $m_AuthInput;
    var $m_UseReplyList;
    var $m_UseCategory;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCEditBoardData()
    {
        $this->KCBoardManagerUI();
        $this->m_BoardManager  = new KCBoardManager;
        $this->m_Description   = new KCTextBox("Description");
        $this->m_UseFlag       = new KCFlagSB("UseFlag");
        $this->m_TplDirectory  = new KCSkinSB("TplDirectory");
        $this->m_TplHeader     = new KCTextBox("TplHeader");
        $this->m_TplFooter     = new KCTextBox("TplFooter");
        $this->m_TplList       = new KCTextBox("TplList");
        $this->m_TplView       = new KCTextBox("TplView");
        $this->m_TplWrite      = new KCTextBox("TplWrite");
        $this->m_TplSmplList   = new KCTextBox("TplSmplList");
        $this->m_ListPerPage   = new KCListPerPageSB("ListPerPage");
        $this->m_BoardTitle    = new KCTextBox("BoardTitle");
        $this->m_TitleImage    = new KCTextBox("TitleImage");
        $this->m_UseTitleImage = new KCFlagSB("UseTitleImage");
        $this->m_LimitStep     = new KCLimitStepSB("LimitStep");
        $this->m_MaxUpload     = new KCUploadSB("MaxUpload");
        $this->m_AuthList      = new KCPermSB("AuthList");
        $this->m_AuthView      = new KCPermSB("AuthView");
        $this->m_AuthInput     = new KCPermSB("AuthInput");
        $this->m_UseReplyList  = new KCFlagSB("UseFlag");
        $this->m_UseCategory   = new KCFlagSB("UseCategory");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardManagerTemplate()
    {
        $this->SetTemplate("EditBoardData.ihtml");
        //$this->SetBlock();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        if(!$this->m_IsSetKey)
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "߸ Ķ Դϴ. Table  ϴ.");
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetFirstData()
    {
        $this->LoadManagerData();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetManagerUIValue()
    {
        $this->m_Template->set_var("DEFAULTPARAM", $this->m_PageManager->GetHiddenParam());
        $this->m_Template->set_var("KBOARD_MANAGER", KBOARD_MANAGER);
        $this->m_Template->set_var("KBOARD_PATH", KBOARD_PATH);
        $this->m_ListPerPage->SetAttribute("class", "forms");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadManagerData()
    {
        if($this->m_BoardManager->LoadData($this->m_TableName))
        {
            $this->m_Description->SetValue ($this->m_BoardManager->m_Description);
            $this->m_TplDirectory->LoadData();
            $this->m_TplHeader->SetValue   ($this->m_BoardManager->m_TplHeader);
            $this->m_TplFooter->SetValue   ($this->m_BoardManager->m_TplFooter);
            $this->m_TplList->SetValue     ($this->m_BoardManager->m_TplList);
            $this->m_TplView->SetValue     ($this->m_BoardManager->m_TplView);
            $this->m_TplWrite->SetValue     ($this->m_BoardManager->m_TplWrite);
            $this->m_TplSmplList->SetValue ($this->m_BoardManager->m_TplSmplList);
            $this->m_ListPerPage->LoadData();
            $this->m_BoardTitle->SetValue  ($this->m_BoardManager->m_BoardTitle);
            $this->m_TitleImage->SetValue  ($this->m_BoardManager->m_TitleImage);
            $this->m_LimitStep->LoadData();
            $this->m_MaxUpload->LoadData();
            $this->m_UseFlag->LoadData();
            $this->m_AuthList->LoadData();
            $this->m_AuthView->LoadData();
            $this->m_AuthInput->LoadData();
            $this->m_UseReplyList->LoadData();
            $this->m_UseCategory->LoadData();
            $this->m_UseTitleImage->LoadData();

            $this->m_Template->set_var(array(
                TABLENAME     => $this->m_BoardManager->m_TableName,
                DESCRIPTION   => $this->m_Description->GetValue(),
                USEFLAG       => $this->m_UseFlag->SBBind($this->m_BoardManager->m_UseFlag),
                REGDATE       => $this->m_BoardManager->m_RegDate,
                TPLDIRECTORY  => $this->m_TplDirectory->SBBind($this->m_BoardManager->m_TplDirectory),
                TPLHEADER     => $this->m_TplHeader->GetValue(),
                TPLFOOTER     => $this->m_TplFooter->GetValue(),
                TPLLIST       => $this->m_TplList->GetValue(),
                TPLVIEW       => $this->m_TplView->GetValue(),
                TPLWRITE      => $this->m_TplWrite->GetValue(),
                TPLSMPLLIST   => $this->m_TplSmplList->GetValue(),
                LISTPERPAGE   => $this->m_ListPerPage->SBBind($this->m_BoardManager->m_ListPerPage),
                BOARDTITLE    => $this->m_BoardTitle->GetValue(),
                TITLEIMAGE    => $this->m_TitleImage->GetValue(),
                USETITLEIMAGE => $this->m_UseTitleImage->SBBind($this->m_BoardManager->m_UseTitleImage),
                PDSDIRECTORY  => $this->m_BoardManager->m_PdsDirectory,
                LIMITSTEP     => $this->m_LimitStep->SBBind($this->m_BoardManager->m_LimitStep),
                UPLOAD        => $this->m_MaxUpload->SBBind($this->m_BoardManager->m_MaxUpload),
                AUTHLIST      => $this->m_AuthList->SBBind($this->m_BoardManager->m_AuthList),
                AUTHVIEW      => $this->m_AuthView->SBBind($this->m_BoardManager->m_AuthView),
                AUTHINPUT     => $this->m_AuthInput->SBBind($this->m_BoardManager->m_AuthInput),
                USEREPLYLIST  => $this->m_UseReplyList->SBBind($this->m_BoardManager->m_UseReplyList),
                USECATEGORY   => $this->m_UseCategory->SBBind($this->m_BoardManager->m_UseCategory)
            ));
        }
        else
        {
            echo "Data load ߽ϴ.";
        }
    }


    /* --------------------------------------------------
     * access : private
     * event function
     * -------------------------------------------------- */
    function UpdateBoardData()
    {
        global  $HTTP_POST_VARS;
        $this->m_BoardManager->SetDataValue($HTTP_POST_VARS);
        if(!$this->m_BoardManager->UpdateData($this->m_TableName))
        {
            if($this->m_BoardManager->m_ErrCode == $this->m_BoardManager->QUERY_RESULT_ZERO)
            {
                $this->m_JSUtil->AlertBack("  Ÿ ϴ.     ҹư Ŭϼ");
            }
            else
            {
                $this->m_JSUtil->AlertBack($this->m_BoardManager->m_ErrCode . "  ߻߽ϴ.");
            }
        }
        $this->GoNextPage("ManagerList.php");
    }


    /* --------------------------------------------------
     * access : private
     * event function
     * -------------------------------------------------- */
    function CancelBoardData()
    {
        $this->GoNextPage("ManagerList.php");
    }
}
?>