/*
MySQL Backup
Source Host:           localhost
Source Server Version: 4.0.13-nt
Source Database:       test
Date:                  2003-08-02 23:14:48
*/

#----------------------------
# Table structure for kb_beta_test
#----------------------------
create table `[TABLENAME]` (
   Id int(11) not null auto_increment,
   Category int(11) not null default '0',
   Name varchar(20),
   EMail varchar(80),
   Homepage varchar(255),
   Subject varchar(255) not null,
   Contents text,
   Passwd varchar(50) not null,
   Wdate datetime not null default '0000-00-00 00:00:00',
   Ip varchar(20) not null,
   Hit int(11) not null default '0',
   Ref int(11) not null default '0',
   Step int(11) not null default '0',
   ReLevel int(11) not null default '0',
   Pds smallint(2) unsigned not null default '0',
   TopOrder smallint(6) not null default '0',
   ViewHtml char(1) not null default 'T',
   `Comment` smallint(6) not null default '0',
   Scope smallint(11) not null default '0',
   OrgScope smallint(6) not null default '0',
   ParentId int(11) not null default '0',
   Deleted tinyint(4) not null default '0',
   primary key (Id),
   index SortIndex (Scope, TopOrder, Ref, ReLevel),
   index Scope (Scope),
   index ParentId (ParentId),
   index OrgScope (OrgScope,Category),
   index Ref (Ref),
   index TopOrder (TopOrder));

#----------------------------
# Table structure for kb_beta_test_category
#----------------------------
create table `[TABLENAME]_category` (
   Idx int(11) not null auto_increment,
   categoryName varchar(20) not null,
   categoryOrder smallint(6) not null default '0',
   primary key (Idx));

#----------------------------
# Table structure for kb_beta_test_comment
#----------------------------
create table `[TABLENAME]_comment` (
   Idx int(11) not null auto_increment,
   PIdx int(11) not null default '0',
   Writer varchar(20) not null,
   DatComment text not null,
   Passwd varchar(50) not null,
   RegDate datetime not null default '0000-00-00 00:00:00',
   primary key (Idx),
   index PIdx (PIdx));

#----------------------------
# Table structure for kb_beta_test_scope
#----------------------------
create table `[TABLENAME]_scope` (
   Scope int(11) not null default '0',
   ScopeStart int(11) not null default '0',
   ScopeEnd int(11) not null default '0',
   TopScopeOrder tinyint(4) not null default '0',
   primary key (Scope),
   index ScopeRange (ScopeStart, ScopeEnd),
   index ScopeStart (ScopeStart),
   index ScopeEnd (ScopeEnd));

#----------------------------
# Table structure for kb_beta_test_upload
#----------------------------
create table `[TABLENAME]_upload` (
   Id int(11) not null auto_increment,
   BoardId int(11) not null default '0',
   FileName varchar(255) not null,
   SaveFileName varchar(255) not null,
   ContentType varchar(50) not null,
   FileSize varchar(15) not null,
   DownLoad int(11) not null default '0',
   primary key (Id),
   index BoardId (BoardId));

#----------------------------
# Category ⺻  
#----------------------------
insert  into `[TABLENAME]_category` values (0, 'Ϲ', 0)