<?
/*
 ************************************************************************
 * File Name  : KCBoardManager.php
 * Class Name : KCBoardManager
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002 Na Jong Sung <konlo@konlo.net>
 * All Rights Reserved.
 * http://www.konlo.net
 * function   :
 * Modify     : 2003.09.27
              : Խ  _scope ̺   
 ************************************************************************
 */


if(!defined("KCDATABASE"))   require(K_LIB_PATH . "/KCDataBase.php");
if(!defined("KCFILEUPLOAD")) require(KBOARD_CLASS . "/KCFileUpload.php");

define("KCBOARDMANAGER", true);
class KCBoardManager extends KCDataBase
{
    var $m_TableName;
    var $m_Description;
    var $m_UseFlag;
    var $m_RegDate;
    var $m_TplDirectory;
    var $m_TplHeader;
    var $m_TplFooter;
    var $m_TplList;
    var $m_TplView;
    var $m_TplWrite;
    var $m_TplSmplList;
    var $m_ListPerPage;
    var $m_BoardTitle;
    var $m_TitleImage;
    var $m_UseTitleImage;
    var $m_LimitStep;
    var $m_MaxUpload;
    var $m_AuthList;
    var $m_AuthView;
    var $m_AuthInput;
    var $m_UseReplyList;
    var $m_UseCategory;

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function KCBoardManager()
    {
        $this->KCDataBase();
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function SetDefaultDataValue(
        $TableName,
        $Description)
    {
        if($Replace)
        {
            $this->m_TableName   = str_replace("'", "''", $TableName);
            $this->m_Description = str_replace("'", "''", $Description);
        }
        else
        {
            $this->m_TableName   = $TableName;
            $this->m_Description = $Description;
        }
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function LoadData($TableName)
    {
        $Ret = false;
        $Query = "SELECT * FROM kb_boardmanager WHERE tableName = '$TableName' ";
        $result  = $this->m_DbMan->query($Query);
        if($result)
        {
            if($this->m_DbMan->next_record())
            {
                $this->m_TableName     = $this->m_DbMan->f("TableName");
                $this->m_Description   = $this->m_DbMan->f("Description");
                $this->m_UseFlag       = $this->m_DbMan->f("UseFlag");
                $this->m_RegDate       = $this->m_DbMan->f("RegDate");
                $this->m_TplDirectory  = $this->m_DbMan->f("TplDirectory");
                $this->m_TplHeader     = $this->m_DbMan->f("TplHeader");
                $this->m_TplFooter     = $this->m_DbMan->f("TplFooter");
                $this->m_TplList       = $this->m_DbMan->f("TplList");
                $this->m_TplView       = $this->m_DbMan->f("TplView");
                $this->m_TplWrite      = $this->m_DbMan->f("TplWrite");
                $this->m_TplSmplList   = $this->m_DbMan->f("TplSmplList");
                $this->m_ListPerPage   = $this->m_DbMan->f("ListPerPage");
                $this->m_BoardTitle    = $this->m_DbMan->f("BoardTitle");
                $this->m_TitleImage    = $this->m_DbMan->f("TitleImage");
                $this->m_UseTitleImage = $this->m_DbMan->f("UseTitleImage");
                $this->m_LimitStep     = $this->m_DbMan->f("LimitStep");                
                $this->m_MaxUpload     = $this->m_DbMan->f("MaxUpload");
                $this->m_AuthList      = $this->m_DbMan->f("AuthList");
                $this->m_AuthView      = $this->m_DbMan->f("AuthView");
                $this->m_AuthInput     = $this->m_DbMan->f("AuthInput");
                $this->m_UseReplyList  = $this->m_DbMan->f("UseReplyList");
                $this->m_UseCategory   = $this->m_DbMan->f("UseCategory");
                $Ret = true;
            }
        }
        else
        {
            $this->m_ErrMsg = $this->m_DbMan->m_ErrMsg;
        }
        return $Ret;
    }



    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function CreateBoard($TableName)
    {
        $Ret = false;
        $filename = KBOARD_MANAGER . "/SQL/CreateBoard.sql";

        //Check SQL file
        if(file_exists($filename))
        {
            if(!$this->IsExistTable($TableName))
            {
                $handle = fopen ($filename, "r");
                $CreateSQL = fread ($handle, filesize ($filename));
                fclose ($handle);
                $CreateSQL = str_replace("[TABLENAME]", $TableName, trim($CreateSQL));
                $SQLs = split(";", $CreateSQL);
                foreach($SQLs as $ExecuteSQL)
                {
                    if(!empty($ExecuteSQL))
                    {
                        $Ret = $this->ExecuteQuery($ExecuteSQL);
                    }
                }
            }
            else
            {
                $this->m_ErrMsg = "$TableName  ϴ Table Դϴ.";
            }
        }
        else
        {
            $this->m_ErrMsg = "$filename   ʽϴ.";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     * Set Data Value. Fill Web DataValue to Property.
     * $DataValue is array data type.
     * override
     * --------------------------------------------------*/
    function SetDataValue($DataValue)
    {
        $this->m_Description   = $DataValue["Description"];
        $this->m_UseFlag       = $DataValue["UseFlag"];
        $this->m_TplDirectory  = $DataValue["TplDirectory"];
        $this->m_TplList       = $DataValue["TplList"];
        $this->m_TplHeader     = $DataValue["TplHeader"];
        $this->m_TplFooter     = $DataValue["TplFooter"];
        $this->m_TplView       = $DataValue["TplView"];
        $this->m_TplWrite      = $DataValue["TplWrite"];
        $this->m_TplSmplList   = $DataValue["TplSmplList"];
        $this->m_ListPerPage   = $DataValue["ListPerPage"];
        $this->m_BoardTitle    = $DataValue["BoardTitle"];
        $this->m_TitleImage    = $DataValue["TitleImage"];
        $this->m_LimitStep     = $DataValue["LimitStep"];
        $this->m_MaxUpload     = $DataValue["MaxUpload"];
        $this->m_AuthList      = $DataValue["AuthList"];
        $this->m_AuthView      = $DataValue["AuthView"];
        $this->m_AuthInput     = $DataValue["AuthInput"];
        $this->m_UseReplyLis   = $DataValue["UseReplyList"];
        $this->m_UseCategory   = $DataValue["UseCategory"];
        $this->m_UseTitleImage = $DataValue["UseTitleImage"]; 
        
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function RemoveTable($TableName)
    {
        $Ret = true;
        $Query = "DELETE FROM kb_boardmanager WHERE TableName ='$TableName' ";
        if($this->AffectOperate($Query))
        {
            //Board Table
            $Query = "DROP TABLE `$TableName`";
            $Ret &= $this->ExecuteQuery($Query);

            //MaxUpload Table
            $Query = "DROP TABLE `" . $TableName. "_upload`";
            $Ret &= $this->ExecuteQuery($Query);
            
            //Comment Table
            $Query = "DROP TABLE `" . $TableName. "_comment`";
            $Ret &= $this->ExecuteQuery($Query);            

            //Category Table
            $Query = "DROP TABLE `" . $TableName. "_category`";
            $Ret &= $this->ExecuteQuery($Query);
            
            //Category Table
            $Query = "DROP TABLE `" . $TableName. "_scope`";
            $Ret &= $this->ExecuteQuery($Query);            
            
            // Delete UploadFile
            $FileUpload = new KCFileUpload( UPLOAD_PATH ."/$TableName");
            $FileUpload->RemoveUploadDir( UPLOAD_PATH ."/$TableName");                                    
        }
        return $Ret;
    }



    /* --------------------------------------------------
     * access : protected
     * virtual function.
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO kb_boardmanager
                    (TableName, Description, TplDirectory,
                         RegDate)
                VALUES('$this->m_TableName', '$this->m_Description', 'voy_window_green',
                        now()) ";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetUpdateSQL($TableName)
    {
        return "UPDATE kb_boardmanager SET
                    Description   = '$this->m_Description',
                    UseFlag       = '$this->m_UseFlag',
                    TplDirectory  = '$this->m_TplDirectory',
                    TplHeader     = '$this->m_TplHeader',
                    TplFooter     = '$this->m_TplFooter',
                    TplList       = '$this->m_TplList',
                    TplView       = '$this->m_TplView',
                    TplWrite      = '$this->m_TplWrite',
                    TplSmplList   = '$this->m_TplSmplList',
                    ListPerPage   = '$this->m_ListPerPage',
                    BoardTitle    = '$this->m_BoardTitle',
                    TitleImage    = '$this->m_TitleImage',
                    UseTitleImage = '$this->m_UseTitleImage',
                    LimitStep     = '$this->m_LimitStep',
                    MaxUpload     = '$this->m_MaxUpload',
                    AuthList      = '$this->m_AuthList',
                    AuthView      = '$this->m_AuthView',
                    AuthInput     = '$this->m_AuthInput',
                    UseReplyList  = '$this->m_UseReplyList',
                    UseCategory   = '$this->m_UseCategory'
                WHERE TableName = '$TableName' ";
    }
}
?>