<?
/*
 ************************************************************************
 * File Name  : KCBoardManagerUI.php
 * Class Name : KCBoardManagerUI
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * function   :
 ************************************************************************
 */

require(KBOARD_CLASS.  "/KCKonloBoardUI.php");
require(K_LIB_PATH  .  "/KCPageManager.php");
define("KCBOARDMANAGERUI", true);
class KCBoardManagerUI extends KCKonloBoardUI
{
    var $m_TableName;
    var $m_PageManager;
    var $m_SearchField;
    var $m_SearchWord;
    var $m_SearchFlag;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardManagerUI()
    {
        $this->KCKonloBoardUI();
        $this->m_TableName = null;
        $this->m_SearchFlag = false;
        $this->m_PageManager = new KCPageManager;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetAuth()
    {
        $this->m_IsAuth  = $this->m_Auth->IsAuth();
        $this->m_IsAdmin = $this->m_Auth->IsAdmin("adminpage");
    }


    /* --------------------------------------------------
     * access :
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetHeaderTemplate("BoardHeader.ihtml");
        $this->SetFooterTemplate("Boardfooter.ihtml");
        $this->BoardManagerTemplate();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetUIValue()
    {        
        $this->m_Template->set_var(array(
            "DEFAULTPARAM"     => $this->m_PageManager->GetHiddenParam(),
            "K_JSLIB_PATH"     => K_JSLIB_PATH,
            "KBOARD_WEB_ROOT"  => KBOARD_WEB_ROOT,
            "K_WEB_ROOT"       => K_WEB_ROOT
            ));
        $this->SetManagerUIValue();        
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */    
    function SetManagerUIValue()
    {
        ;   
    }
    

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_TableName = $HTTP_GET_VARS[$this->TABLE_PARAM_NAME];
        if($this->m_TableName != null && $this->m_TableName != "")
        {
            $this->m_IsSetKey = true;
        }
        $this->m_PageManager->SetHiddenValue("pn", $HTTP_GET_VARS["pn"]);

        if($HTTP_GET_VARS["sw"] != "")
        {
            $this->m_SearchField = $HTTP_GET_VARS["sf"];
            $this->m_SearchWord  = $HTTP_GET_VARS["sw"];
            $this->m_PageManager->SetHiddenValue("sf", $HTTP_GET_VARS["sf"]);
            $this->m_PageManager->SetHiddenValue("sw", $HTTP_GET_VARS["sw"]);
            $this->m_SearchFlag = true;
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function CheckWebParameter()
    {
        if(!$this->IsAdmin())
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "ڰ ƴմϴ.");
        }
        $this->ExtraCheckWebParameter();

        if(!$this->m_CheckData->CheckData())
        {
            $this->m_JSUtil->AlertBack($this->m_CheckData->m_ErrMsg);
        }
    }
}
?>