<?
/*
 ************************************************************************
 * File Name  : KCBoardUI.php
 * Class Name : KCBoardUI
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 * All Rights Reserved.
 * http://www.konlo.net
 * function   :
 * Modify     : 2003. 8. 10.
 ************************************************************************
 */

if(!defined("KCKONLOBOARDUI")) require(KBOARD_CLASS. "/KCKonloBoardUI.php");
if(!defined("KCBOARDMANAGER")) require(KBOARD_CLASS. "/KCBoardManager.php");
if(!defined("KCSCOPE"))        require(KBOARD_CLASS. "/KCScope.php");
if(!defined("KCPAGEMANAGER"))  require(K_LIB_PATH.   "/KCPageManager.php");
if(!defined("KCSTRING"))       require(K_LIB_PATH.   "/KCString.php");

define("KCBOARDUI", true);
class KCBoardUI extends KCKonloBoardUI
{
    var $m_BoardTable;
    var $m_BoardManager;
    var $m_TableIdx;
    var $m_PageManager;
    var $m_CategoryValue;

    var $m_SearchField;
    var $m_SearchWord;
    var $m_SearchFlag;
    var $m_CategoryFlag;              // Category˻ ̷
    var $m_BoardTitleFlag;
    var $m_Scope; 

    var $SEARCH_FIELD_SUBJECT  = "s";
    var $SEARCH_FIELD_CONTENTS = "c";
    var $SEARCH_FIELD_NAME     = "n";
    var $SEARCH_FIELD_CATEGORY = "ct";
    

    var $BOARD_PERM_NOBODY = "nobody";
    var $BOARD_PERM_MEMBER = "member";
    var $BOARD_PERM_ADMIN  = "admin";
    
    var $m_IsDisplayHeader;
    var $m_IsDisplayBody;
    var $m_IsDisplayFooter;    
    var $TEMPLATE_PATH;    

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardUI()
    {
        $this->KCKonloBoardUI();
        $this->m_BoardTitleFlag  = true;
        $this->m_BoardManager    = new KCBoardManager;
        $this->m_PageManager     = new KCPageManager;
        $this->m_IsDisplayHeader = true;
        $this->m_IsDisplayBody   = true;
        $this->m_IsDisplayFooter = true;        
        $this->TEMPLATE_PATH     = KBOARD_BOARD . "/template" ;
        $this->m_Scope           = null;
        $this->m_SearchFlag      = false;
        $this->m_CategoryFlag    = false;
    }


    /* --------------------------------------------------
     * access :
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate($this->TEMPLATE_PATH . "/".$this->m_BoardManager->m_TplDirectory);
        
        if($this->m_IsDisplayHeader)
        {            
            $this->SetHeaderTemplate($this->m_BoardManager->m_TplHeader);
            $this->SetHeaderBlock("timage",    "ttimage");        
            $this->SetHeaderBlock("adminlink", "tadminlink");        
            
        }        
        if($this->m_IsDisplayFooter)
        {
            $this->SetFooterTemplate($this->m_BoardManager->m_TplFooter);        
        }        
        $this->BoardTemplate();        
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetUIValue()
    {
        global $REQUEST_URI;
        global $HTTP_HOST;
        if($this->IsAuth())
        {
            $RegText  = " ";
            $LogLink  = "Logout.php";
            $LogText  = "α׾ƿ";
            $LogImage = "kb_logout.gif";
            if($this->IsAdmin())
            {                
                if($this->m_IsDisplayHeader)
                {
                    $this->m_Template->parse("tadminlink", "adminlink");                
                }
            }
        }
        else        
        {   
            $RegText = "ȸ ";
            $LogLink = "GLogin.php";            
            $LogText = "α";
            $LogImage = "kb_login.gif";
        }
        
        if($this->m_IsDisplayHeader)
        {            
            if($this->m_BoardManager->m_UseTitleImage == "T")
            {
                $BoardTitle = $this->m_Template->get_var("timage");                
            }            
        }
        
        $this->m_Template->set_var(array(
                "DEFAULTPARAM"    => $this->m_PageManager->GetHiddenParam(),
                "BOARD_TITLE"     => $this->m_BoardManager->m_BoardTitle,
                "REGTEXT"         => $RegText,
                "K_JSLIB_PATH"    => K_JSLIB_PATH,
                "KBOARD_WEB_ROOT" => KBOARD_WEB_ROOT,
                "K_USERREG_WEB"   => K_USERREG_WEB,
                "K_WEB_ROOT"      => K_WEB_ROOT,
                "K_LOGIN_WEB"     => K_LOGIN_WEB,
                "ADMIN_WEB"       => ADMIN_WEB,
                "REQUEST_URI"     => urlencode($REQUEST_URI),
                "LOGLINK"         => $LogLink,
                "LOGTEXT"         => $LogText,
                "LOGIMAGE"        => $LogImage,
                "BOARD_WEB_ROOT"  => BOARD_WEB_ROOT,
                "ttimage"         => $BoardTitle,
                "TITLEIMAGE"      => $this->m_BoardManager->m_TitleImage,
                "SKIN"            => $this->GetSkinPath(),
                "HTTP_HOST"       => $HTTP_HOST
                ));
        $this->SetBoardUIValue();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * ---------------------------------------------*/
    function SetWebParameter()
    {
        global $HTTP_GET_VARS;
        if($this->m_BoardTable == "")
            $this->m_BoardTable = $HTTP_GET_VARS["tb"];

        $this->m_TableIdx   = $HTTP_GET_VARS["tId"];
        if($this->m_TableIdx != null && $this->m_TableIdx != "")
        {
            $this->m_IsSetKey = true;
        }

        if($this->m_BoardTable != null && $this->m_BoardTable != "")
        {
            $this->m_PageManager->SetHiddenValue("tb", $this->m_BoardTable);
        }
        $this->m_PageManager->SetHiddenValue("pn", $HTTP_GET_VARS["pn"]);  //Page number


        // Search Word
        if($HTTP_GET_VARS["sw"] != "")
        {
            $this->m_SearchField   = $HTTP_GET_VARS["sf"];
            $this->m_SearchWord    = $HTTP_GET_VARS["sw"];            
            $this->m_PageManager->SetHiddenValue("sf", $HTTP_GET_VARS["sf"]);
            $this->m_PageManager->SetHiddenValue("sw", $HTTP_GET_VARS["sw"]);            
            $this->m_SearchFlag = true;
            $this->SetDefaultScope();
            
        }
        
        //Category 
        if($HTTP_GET_VARS["ct"] != "")
        {
            $this->m_CategoryFlag = true;
            $this->SetDefaultScope();
            $this->m_CategoryValue = $HTTP_GET_VARS["ct"];
            $this->m_PageManager->SetHiddenValue("ct", $HTTP_GET_VARS["ct"]);
            $this->m_PageManager->SetHiddenValue("cn", $this->m_Scope);  //Scope number;                             
        }

        $this->SetExtraWebParameter();
    }
    
    
    
    /* --------------------------------------------------
     * access : protected
     * Լ Search Ǵ Category   ȣȴ.
     * ---------------------------------------------*/    
    function SetDefaultScope()
    {
        // Scope   Ѵ. 
        //     ְ ´.   
        global $HTTP_GET_VARS;
        if($this->m_Scope == null)
        {
            $this->m_Scope = $HTTP_GET_VARS["cn"];
            if($this->m_Scope == "")
            {              
                $this->m_Scope = null; // ٽ ʱȭ             
                $this->LoadMaxScope();
            }                    
        }
    }
    

    /* --------------------------------------------------
     * access : protected
     * override
     * ---------------------------------------------*/
    function LoadMaxScope()
    {
        if($this->m_Scope == null)
        {
            $ScopeMng = new KCScope($this->m_BoardTable);
            $ScopeMng->LoadMaxData();                
            $this->m_Scope = $ScopeMng->m_Scope;            
            $this->m_PageManager->SetHiddenValue("cn", $this->m_Scope);  //Scope number;                             
        }        
    }

    /* --------------------------------------------------
     * access : protected
     * override
     * ---------------------------------------------*/
    function CheckWebParameter()
    {        
        $this->m_CheckData->SetCheckValue($this->m_BoardTable, "", "Table  ϴ.");
        $this->CheckTableName();
        $this->SetAdminAuth($this->m_BoardTable);
        $this->ExtraCheckWebParameter();
        if(!$this->m_CheckData->CheckData())
        {
            $this->m_JSUtil->AlertBack($this->m_CheckData->m_ErrMsg);
            exit();
        }
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function MarkSearchWord($Value, $SearchField)
    {
        if($this->m_SearchFlag)
        {
            if($this->m_SearchField == $SearchField)
            {
                $Value = str_replace("$this->m_SearchWord", "<font color=red>$this->m_SearchWord</font>", $Value);
            }
        }
        return $Value;
    }


    /* --------------------------------------------------
     * access : private
     * Check Table Name.
     * -------------------------------------------------- */
    function CheckTableName()
    {

        if($this->m_BoardManager->LoadData($this->m_BoardTable))
        {            
            if($this->m_BoardManager->m_UseFlag == "F")
            {
                $this->m_CheckData->SetCheckValue("-1", "-1", "  Խ Դϴ.");                            
            }
        }
        else
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "߸ Խ ̸Դϴ.");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckPagePerm($PagePerm)
    {

        $ValidFlag = false;
        global $REQUEST_URI;        
        switch($PagePerm)
        {
            case $this->BOARD_PERM_NOBODY:
                $ValidFlag = true;
                break;
            case $this->BOARD_PERM_MEMBER:
                if($this->IsAuth())
                    $ValidFlag = true;
                else
                {
                    $ErrMsg = " ϴ. ۾ α  ̿밡մϴ.";
                }
                break;
            case $this->BOARD_PERM_ADMIN:
                if($this->IsAdmin())
                    $ValidFlag = true;
                else
                    $ErrMsg = " ϴ. ڷ α  ̿ մϴ.";
                break;
        }
        
        // Ÿ ٸ    ѿ   óմϴ.
        if($this->m_CheckData->CheckData())
        {
            if(!$ValidFlag)
                $this->GoLoginPage($ErrMsg);            
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetPrimeSize($Value)
    {
        $Prime = substr($Value, -1, 1);
        $Ret   = substr($Value,  0,  strlen($Value) - 1);
        $Ret   = "$Ret.$Prime";
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetFormat($Value)
    {
        $Ret = 0;
        $String = new KCString($Value);

        if($String->GetLength() > 9)
        {
            $Ret   = $String->Left($String->GetLength() - 8) ;//."GB";
            $Ret = $this->GetPrimeSize($Ret)." GB";

        }
        else if($String->GetLength() > 6)
        {
            $Ret = $String->Left($String->GetLength() - 5);
            $Ret = $this->GetPrimeSize($Ret)." MB";
        }
        else if($String->GetLength() > 3)
        {
            $Ret = $String->Left($String->GetLength() - 2);
            $Ret = $this->GetPrimeSize($Ret)." KB";
        }
        else
        {
            $Ret = $String->GetString(). " B";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardTable($BoardTable)
    {
        $this->m_BoardTable = $BoardTable;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetPageName()
    {
        return $this->m_BoardManager->m_PageName;
    }
    
    
    
    /* --------------------------------------------------
     * access : protected
     * 
     * -------------------------------------------------- */    
    function GetSkinPath()
    {
        return BOARD_WEB_ROOT . "/template/" . $this->m_BoardManager->m_TplDirectory;
    }
}

?>