<?
/*
 ************************************************************************
 * File Name   : KCScope.php
 * Class Name  : KCScope
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 24
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCSCOPE", true);
class KCScope extends KCDataBase
{
    var $m_TableName;
    var $m_Scope;
    var $m_ScopeStart;
    var $m_ScopeEnd;
    var $m_TopScopeOrder;
    var $m_BoardTableName;    
    var $m_OrgScope;           // Board Table   OrgScope
    
    var $m_InsertTotal;        // INSERT  ʱ Total 
    var $m_NewScopeFlag;       // ο Scope Insert ϴ Ѵ. 
    var $SCOPE_RANGE_MAX = 3000;  //Scope  
    
    var $SCOPE_VALUE_DEFAULT  = 1;
    var $SCOPE_VALUE_TOPORDER = 0; //  TopOrder    Scope 
    var $TOPSCOPEORDER_FIRST  = 1; // Top Scope Order  DESC   
                                   // ó  Ǵ . ᱹ SCOPE_VALUE_TOPORDER 
                                   //  ִ Scope order ù°
    var $TOPSCOPEORDER_SECOND = 0; // Top scope order second

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCScope($TableName)
    {
        $this->KCDataBase();
        $this->m_BoardTableName = $TableName;
        $this->m_TableName      = $TableName . "_scope";
        $this->m_NewScopeFlag   = false;
        $this->m_InsertTotal    = null;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function SetDataValue($DataValue)
    {
        
    }

    
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */    
    function GetSelectSQL($Scope)
    {
        return "SELECT * FROM `$this->m_TableName` WHERE Scope = '$Scope' ";
    }
    

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {   
        $Total = $this->GetNewTotal() ;
        return "INSERT INTO `$this->m_TableName`
                    (Scope,        ScopeStart, ScopeEnd, 
                     TopScopeOrder )
                    VALUES('$this->m_Scope', '$Total', '$Total',
                    $this->m_TopScopeOrder
                    ) ";
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * virtual
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Scope         = $DbMan->f("Scope");
        $this->m_ScopeStart    = $DbMan->f("ScopeStart");
        $this->m_ScopeEnd      = $DbMan->f("ScopeEnd");
        $this->m_TopScopeOrder = $DbMan->f("TopScopeOrder");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetDeleteSQL($Scope)
    {
        return "DELETE FROM `$this->m_TableName` WHERE Scope ='$Scope'";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpdateData($TableName, $Idx)
    {
        
    }
    

    /* --------------------------------------------------
     * access : private
     * Scope ִ  Ÿ ε մϴ. 
     * -------------------------------------------------- */    
    function LoadMaxData()
    {
        $Ret = false;
        $Query = "SELECT * FROM `$this->m_TableName` ORDER BY Scope DESC LIMIT 0, 1";
        
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $this->LoadMemberValue($this->m_DbMan);                
                $Ret = true;
            }  
        }
        return $Ret;                
    }
    
    
    /* --------------------------------------------------
     * access : public
     * Scope   Update ش. 
     * Total  ʱ Count  . 
     * ݵ LoadScopeData() ȣؾѴ.
     * -------------------------------------------------- */        
    function UpdateScope($Scope)
    {
        $Ret = true;
        // Top Order   
        if($Scope == $this->SCOPE_VALUE_TOPORDER)
        {
            $this->m_TopScopeOrder = $this->TOPSCOPEORDER_FIRST;
        }
        else
        {
            $this->m_TopScopeOrder = $this->TOPSCOPEORDER_SECOND;                        
        }
        
        if($this->m_NewScopeFlag)
        {
            $this->m_Scope = $Scope;
            $this->InsertData();
            // Ÿ Է Ŀ Ϲݱ϶  TopOrder Scope ƴ  TopScope Ÿ ϳ ش.
            if($Scope != $this->SCOPE_VALUE_TOPORDER)
            {
                $this->ShiftTopScope();
            }
        }        
        else
        {
            $Ret = $this->IncreaseScope($Scope);
        } 
        return $Ret;
    }
   
   
    /* --------------------------------------------------
     * access : public
     * Scope   Update ش. 
     * ̰ INSERT ü TopOrder Էµ ̸
     * ó Increase غ  Ʈ Ǵ  
     * INSERT Ѵ.
     * -------------------------------------------------- */               
    function ShiftTopScope()
    {
        $Query = "UPDATE `$this->m_TableName` SET 
                      ScopeStart = ScopeStart + 1, 
                      ScopeEnd   = ScopeEnd + 1
                      WHERE Scope = '$this->SCOPE_VALUE_TOPORDER'";
                      
        return $this->ExecuteQuery($Query);                      
                     
    }
   
   
    /* --------------------------------------------------
     * access : public
     * Scope  Count   Ų.
     * -------------------------------------------------- */                
    function IncreaseScope($Scope)
    {
        $Ret = true;
        $Temp = $this;
        //$Scope 0 ƴ ,  0̸ ٸ Scope Start ų ʿ䰡  
        if($Scope != 0)
        {
            $Query = "UPDATE `$Temp->m_TableName` SET ScopeStart = ScopeStart + 1
                          WHERE (Scope >'$Scope' AND TopScopeOrder = '$Temp->TOPSCOPEORDER_SECOND') OR Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                        
            $Ret = $Temp->ExecuteQuery($Query);                                      
        }
        
        if($Scope == 0)
        {
            $Query = "UPDATE `$Temp->m_TableName` SET ScopeEnd = ScopeEnd + 1
                          WHERE Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                        
        }        
        else
        {
            $Query = "UPDATE `$Temp->m_TableName` SET ScopeEnd = ScopeEnd + 1
                          WHERE (Scope >='$Scope' AND TopScopeOrder = '$Temp->TOPSCOPEORDER_SECOND') OR Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                                    
        }

        $Ret = $Temp->ExecuteQuery($Query);
        return $Ret;                                                                 
    }
    
    
    /* --------------------------------------------------
     * access : public
     * Scope  Count   Ų.
     * -------------------------------------------------- */            
    function DecreaseScope($Scope)
    {
        $Ret = false;
        // $this   ϰ ؼ
        $Temp = $this;
        if($Temp->LoadData($Scope))
        {
            // ScopeStart  ScopeEnd     
            if($Temp->m_ScopeStart == $Temp->m_ScopeEnd)
            {
                $Ret = $Temp->DeleteData($Scope);
            }
            
            // ScopeStart 
            // $Scope $Temp->SCOPE_VALUE_TOPORDER  Ŭ   
            // $Scope $Temp->SCOPE_VALUE_TOPORDER ̸ Start  ʿ䰡 
            if($Scope > $Temp->SCOPE_VALUE_TOPORDER)
            {
                $Query = "UPDATE `$Temp->m_TableName` SET ScopeStart = ScopeStart - 1
                              WHERE (Scope >'$Temp->m_Scope' AND TopScopeOrder = '$Temp->TOPSCOPEORDER_SECOND') OR Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                            
                $Ret = $Temp->ExecuteQuery($Query);                                                                                                            
            }        
            
            
            // ScopeEnd . $Scope 0̸ Scope End Scope 1ΰ͸ Ѵ.
            if($Scope == $Temp->SCOPE_VALUE_TOPORDER)
            {
                $Query = "UPDATE `$Temp->m_TableName` SET ScopeEnd = ScopeEnd - 1
                              WHERE Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                            
            }
            else
            {
                $Query = "UPDATE `$Temp->m_TableName` SET ScopeEnd = ScopeEnd - 1
                              WHERE (Scope >='$Temp->m_Scope' AND TopScopeOrder = '$Temp->TOPSCOPEORDER_SECOND') OR Scope = '$Temp->SCOPE_VALUE_TOPORDER' ";                                            
            }

            $Ret = $Temp->ExecuteQuery($Query);                                                                                                                                        
        }
        return $Ret ;   
    }
    
    
    /* --------------------------------------------------
     * access : public
     *  Էµ Scope Ÿ Load մϴ. 
     * $Operation
     *               $OPERATION_INSERT = 0;
     *               $OPERATION_REPLY  = 1;
     *               $OPERATION_UPDATE = 2;
     *                       $Scope  Replay Parent $Scope ̴.
     * $TopOrder           : $TopOrder 0 ū̸ TopOrderScope ε Ѵ.
     * -------------------------------------------------- */            
    function LoadScopeData($Operation, $Scope, $TopOrder)
    {   
        $OPERATION_INSERT = 0;
        $OPERATION_REPLY  = 1;
        $OPERATION_UPDATE = 2;
        $Ret = false;
        

        if($Operation == $OPERATION_REPLY)
        {   
            if(!$this->LoadData($Scope))
            {
                $this->m_ErrMsg = "߸ Scope Դϴ.";
            }           
            $this->m_OrgScope = $this->m_Scope;     
            
        }
        else if($Operation == $OPERATION_UPDATE)
        {
            //Update $Scope   InsertScope LoadѴ.
            if(!$this->LoadData($Scope))
            {
                if($Scope == $this->SCOPE_VALUE_TOPORDER)
                {
                    $this->LoadInsertScopeData($TopOrder);                    
                }
                else
                {
                    $Temp = $this;
                    $Temp->LoadMaxDataEx();
                    // Էµ  MaxScope    ԷѴ.
                    if($Scope == $Temp->m_Scope)
                    {
                        $this->LoadInsertScopeData($TopOrder);
                    }
                    // ׷ ʰ Scope ߰  Ǹ 
                    else
                    {
                        $this->InsertAtScope($Scope, $TopOrder);                    
                    }                                    
                }   
            }
            $this->m_OrgScope = $this->m_Scope;                                         
        }
        // INSERT
        else
        {
            $this->LoadInsertScopeData($TopOrder);
        }
        $Ret = true;        
        return $Ret;
    }
    
    
    /* --------------------------------------------------
     * access : private 
     * Scope ߰    ȴ. 
     * ScopeStart  $Scope 1 ScopeEnd + 1 ȴ. 
     * -------------------------------------------------- */    
    function InsertAtScope($Scope, $TopOrder)
    {
        $Query = "SELECT ScopeEnd FROM `$this->m_TableName` WHERE Scope < $Scope AND Scope != '$this->SCOPE_VALUE_TOPORDER' ORDER BY SCOPE DESC LIMIT 0, 1";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $NewScopeStart = $this->m_DbMan->f("ScopeEnd") + 1;
            }
            // Ÿ   ʱⰪ 1 Ѵ.
            else
            {
                $NewScopeStart = 1;                    
            }
        }
        
        // NewScopeEnd $NewScopeStart 1  ϰ 
        // α׷ 󿡼 Increase  ٽ ϰ ȴ.
        $NewScopeEnd = $NewScopeStart - 1;
        $Query = "INSERT INTO `$this->m_TableName`
                    (Scope,        ScopeStart, ScopeEnd, 
                     TopScopeOrder )
                    VALUES('$Scope', '$NewScopeStart', '$NewScopeEnd',
                    '$TopOrder'
                    ) ";
        return $this->ExecuteQuery($Query); 
    }


    /* --------------------------------------------------
     * access : private 
     * 
     * -------------------------------------------------- */                    
    function LoadInsertScopeData($TopOrder)
    {
        // TopOrder ϰ
        if($TopOrder > 0)
        {
            // Org Scope ؼ LoadMaxData ȣ
            $this->LoadMaxDataEx();
            $this->m_OrgScope = $this->m_Scope;
            
            // TopOrderScope شϴ  ε Ѵ.
            if(!$this->LoadData($this->SCOPE_VALUE_TOPORDER))
            {
                $this->m_Scope        = $this->SCOPE_VALUE_TOPORDER;
                $this->m_NewScopeFlag = true;                                          
            } 
        }
        else
        {   
            $this->m_NewScopeFlag =  $this->LoadMaxDataEx();
            $this->m_OrgScope     = $this->m_Scope;                           
        }      
    }
    
    
    /* --------------------------------------------------
     * access : private
     * Scope ִ  Ÿ ε մϴ. 
     * $Ret    Insert ȯѴ.
     * -------------------------------------------------- */        
    function LoadMaxDataEx()
    {
        $Ret = false;
        if($this->LoadMaxData())
        {
            // Scope TopOrder Scope   ʱⵥŸ
            if($this->m_Scope == 0)
            {
                $this->m_Scope = $this->SCOPE_VALUE_DEFAULT;
                $Ret           = true;                          
            }
            else
            {
                if($this->GetCount() >= $this->SCOPE_RANGE_MAX)
                {
                    $this->m_Scope++;
                    $Ret = true;
                }                                                
            }
        }
        // Ÿ   ʱ  Ѵ. 
        else
        {
            $this->m_Scope = $this->SCOPE_VALUE_DEFAULT;
            $Ret          = true;  
        }
        return $Ret;
    }

    
    /* --------------------------------------------------
     * access : private 
     * Scope شϴ ʱ  ԷѴ. 
     * Scope Total  $Scope   Scope   Count ̴. 
     * -------------------------------------------------- */                
    function GetNewTotal()
    {
        if($this->m_InsertTotal == null)
        {
            $Query = "SELECT ScopeEnd as TotalCount FROM `$this->m_TableName` WHERE TopScopeOrder = '$this->TOPSCOPEORDER_SECOND' ORDER BY Scope DESC LIMIT 0, 1";
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_InsertTotal = $this->m_DbMan->f("TotalCount") + 1;
                }
                // Ÿ   ʱⰪ 1 Ѵ.
                else
                {
                    $this->m_InsertTotal = 1;                    
                }
            }                        
        }
        return $this->m_InsertTotal;        
    }
    
    
    /* --------------------------------------------------
     * access : protected     * 
     * $ScopeOffset :  شϴ Scope ׿ شϴ 
     * Offset ȯѴ. 
     * -------------------------------------------------- */                        
    function GetScopeInfo($ScopeOffset)
    {
        $Scope    = -1;
        $ScopeEnd = -1;
        
        $Query = "SELECT Scope, ScopeEnd  FROM `$this->m_TableName` WHERE ScopeStart <= '$ScopeOffset' AND ScopeEnd >= '$ScopeOffset' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {   
                $Scope    = $this->m_DbMan->f("Scope");
                $ScopeEnd = $this->m_DbMan->f("ScopeEnd");
                
            }                                        
        }        
        return array($Scope, $ScopeEnd);
    }
    
    
    /* --------------------------------------------------
     * access : public
     * Pageȣ شϴ Scope  ȯϴ. 
     * $OffsetFromStart : ۺ ۵Ǵ offset 
     * -------------------------------------------------- */                    
    function GetScopeFromPage($OffsetFromStart)
    {        
        $Scope       = -1;
        $StartOffset = -1;        
        //$Query = "SELECT COUNT(*) AS TotalCount FROM `$this->m_BoardTableName` ";
        $Query = "SELECT ScopeEnd as TotalCount FROM `$this->m_TableName` ORDER BY TopScopeOrder DESC, Scope DESC LIMIT 0, 1";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                // Էϱ Total 
                $Total = $this->m_DbMan->f("TotalCount");               
                // Scope ϰ  offset 
                $ScopeOffset = $Total - $OffsetFromStart;
                
                //TotalScope ϴ Scope  ϱ 
                list($Scope, $ScopeEnd) = $this->GetScopeInfo($ScopeOffset);
                $StartOffset = $ScopeEnd - $ScopeOffset;
            }  
        }
        return array($Scope,$StartOffset) ;
    }
       
    
    /* --------------------------------------------------
     * access : private
     * 
     * -------------------------------------------------- */                        
    function GetCount()
    {
        // ۹ȣ ȣ̱  Count + 1  
        return ($this->m_ScopeEnd - $this->m_ScopeStart) + 1;
    }


    /* --------------------------------------------------
     * access : private
     * BoardTableName COUNT  ȯѴ.
     * -------------------------------------------------- */                            
    function GetTotalTableRecordCount()
    {
        $Ret = 0;
        $Query = "SELECT COUNT(*) AS TotalCount FROM `$this->m_BoardTableName`";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                // Էϱ Total 
                $Ret = $this->m_DbMan->f("TotalCount");
            }
        }        
        return $Ret;
    }    
    
    
    /* --------------------------------------------------
     * access : ScopeEnd ִ  ȯ
     * 
     * -------------------------------------------------- */                                
    function GetMaxScopeEnd()
    {
        $Ret = 0;
        $Query = "SELECT MAX(ScopeEnd) as MaxScopeEnd FROM `$this->m_TableName`";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                // Էϱ Total 
                $Ret = $this->m_DbMan->f("MaxScopeEnd");
            }
        }
        return $Ret;        
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * Board ȿ ¿ ִ ˻մϴ. 
     * -------------------------------------------------- */                            
    function IsValidScope()
    {
        $TableTotalRecordCount = $this->GetTotalTableRecordCount();
        $MaxScopeEnd           = $this->GetMaxScopeEnd();
        return $this->IsValidScopeEx($TableTotalRecordCount, $MaxScopeEnd);
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * Board ȿ ¿ ִ ˻մϴ. 
     * -------------------------------------------------- */                                
    function IsValidScopeEx($TotalRecord, $MaxScopeEnd)
    {
        if($TotalRecord == $MaxScopeEnd)
        {
            $Ret = true;
        }
        else
        {
            $Ret = false;
        }
        return $Ret;        
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * Delete All Scope
     * -------------------------------------------------- */                                        
    function DeleteAll()
    {
        $Query = "DELETE FROM `$this->m_TableName`";
        $this->ExecuteQuery($Query);
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * 带 Correct մϴ. 
     * -------------------------------------------------- */                                    
    function CorrectBoard()
    {
        $TopScope      = null;
        $TopScopeCount = null;
        $Accumulation  = 0;
        $Temp =$this;
        $this->DeleteAll();
        $Query = "SELECT COUNT(*) AS ScopeCount, Scope FROM `$this->m_BoardTableName` GROUP By Scope ORDER BY Scope";
        if($this->m_DbMan->query($Query))
        {
            while($this->m_DbMan->next_record())
            {
                $ScopeCount = $this->m_DbMan->f("ScopeCount");
                $Scope      = $this->m_DbMan->f("Scope");
                
                if($Scope == $this->SCOPE_VALUE_TOPORDER)
                {
                    $TopScope      = $Scope;
                    $TopScopeCount = $ScopeCount;
                }
                else
                {
                    $TopScopeOrder = $this->TOPSCOPEORDER_SECOND;
                    $Accumulation ++;
                    $ScopeStart = $Accumulation;
                    $ScopeEnd   = $Accumulation += ($ScopeCount - 1);
                                    
                    $Query = "INSERT INTO `$this->m_TableName`(Scope, ScopeStart, ScopeEnd, TopScopeOrder)
                            VALUES('$Scope', '$ScopeStart', '$ScopeEnd', '$TopScopeOrder')";
                    $Temp->ExecuteQuery($Query);
                }

            }
            
            //  Top Scope ־ش.
            if($TopScope != null)
            {
                $Accumulation ++;
                $ScopeStart = $Accumulation;
                $ScopeEnd   = $Accumulation += ($TopScopeCount - 1);                
                $Query = "INSERT INTO `$this->m_TableName`(Scope, ScopeStart, ScopeEnd, TopScopeOrder)
                        VALUES('$this->SCOPE_VALUE_TOPORDER', '$ScopeStart', '$ScopeEnd', '$this->TOPSCOPEORDER_FIRST')";
                $this->ExecuteQuery($Query);                        
            }
        }                
    }
}
?>