<?
/*
 ************************************************************************
 * File Name  : KCArrayList.php
 * Class Name : KCArrayList
 * version    : 0.1
 * Copyright 2001, 2002 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * Comment :
 * This class have a array variable.
 * Every function is related with array variable.
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
define("KCARRAYLIST", TRUE);
class KCArrayList extends KCCommonClass
{
    var $m_ArrayList;
    function KCArrayList()
    {
        $this->KCCommonClass();
        $this->m_ArrayList = array();
    }


    /* --------------------------------------------------
     * Add new value at end element.
     * --------------------------------------------------*/
    function AddValue($value)
    {
        array_push($this->m_ArrayList, $value);
    }


    /* --------------------------------------------------
     * Add key and value.
     * --------------------------------------------------*/
    function AddKeyValue($key, $value)
    {
        $this->m_ArrayList[$key] = $value;
    }


    /* --------------------------------------------------
     * Remove All array value.
     * --------------------------------------------------*/
    function Clear()
    {
        unset($this->m_ArrayList);
    }


    /* --------------------------------------------------
     * Remove value in array
     * --------------------------------------------------*/
    function Remove($value)
    {
        if(in_array($value, $this->m_ArrayList, true))
        {
            $key = array_search("$value", $this->m_ArrayList);
            if($key !== false)
            {
                unset($this->m_ArrayList[$key]);
            }
        }
    }


    /* --------------------------------------------------
     * Remove value at index
     * --------------------------------------------------*/
    function RemoveAt($index)
    {
        unset($this->m_ArrayList[$index]);
    }


    /* --------------------------------------------------
     * Insert value at index.
     * --------------------------------------------------*/
    function Insert($index, $value)
    {
        if($this->Count() > 0)
        {
            $newArray = array();
            for($i = 0 ; $i < $this->Count() ; $i ++)
            {
                if($index === $i)
                {
                    array_push($newArray, $value);
                }
                array_push($newArray, $this->m_ArrayList[$i]);
            }
            $this->m_ArrayList = $newArray;
        }
        else
        {
            $this->AddValue($value);
        }
    }


    /* --------------------------------------------------
     * Get value at index.
     * --------------------------------------------------*/
    function GetAt($index)
    {
        return $this->m_ArrayList[$index];
    }


    /* --------------------------------------------------
     * Get Array count.
     * --------------------------------------------------*/
    function Count()
    {
        return count($this->m_ArrayList);
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetStringFromArray($Array, $Delimiter = ",")
    {
        $Ret = "";
        for( $i = 0 ; $i < count($Array) ; $i ++)
        {
            $Ret .= $Array[$i];
            if($i + 1 < count($Array))
            {
                $Ret .= ", ";
            }            
        }        
        return $Ret;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */    
    function GetString($Delimiter = ",")
    {
        return $this->GetStringFromArray($this->m_ArrayList, $Delimiter);
    }
}

 ?>