<?
/*
 ************************************************************************
 * File Name  : KCDataBase.php
 * Class Name : KCDataBase
 * version    :
 * Copyright 2001, 2002 Na Jong Sung <konlo@konlo.net>
 * All Rights Reserved.
 * http://www.konlo.net
 * This class is database class for table.
 * Update Date : 2003. 7. 24
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
if(!defined("KCDBSQL"))       require(K_LIB_PATH . "/KCDbSql.php");

define("KCDATABASE", true);
class KCDataBase extends KCCommonClass
{
    var $m_DbMan ;
    var $m_DataValue = array();
    var $fpSelectSQL ;  //function Pointer;
    var $QUERY_RESULT_ZERO     = "QUERY_RESULT_ZERO";
    var $QUERY_RESULT_ONEMORE  = "QUERY_RESULT_ONEMORE";
    var $MYSQL_ERROR_DUPLICATE = "MYSQL_ERROR_DUPLICATE";
    
    var $m_Operation = null;   // ۾ ¸  
    
   
    var $OPERATION_INSERT = 0;
    var $OPERATION_UPDATE = 1;
    var $OPERATION_DELETE = 2;
    var $OPERATION_SELECT = 3;


    /* --------------------------------------------------
     * ctor.
     * --------------------------------------------------*/
    function KCDataBase()
    {
        $this->KCCommonClass();
        $this->m_DbMan = new KCDbSql;
        $this->fpSelectSQL = "GetSelectSQL";
    }


    /* --------------------------------------------------
     * access : public
     * Set Data Value. Fill Web DataValue to Property.
     * $DataValue is array data type.
     * --------------------------------------------------*/
    function SetDataValue($DataValue)
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function.
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "";
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function InsertData()
    {
        $Query = $this->GetInsertSQL();
        return $this->AffectOperate($Query);
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function GetUpdateSQL($Idx)
    {
        return "";
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function UpdateData($Idx)
    {
        $Query = $this->GetUpdateSQL($Idx);
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function GetDeleteSQL($Idx)
    {
        return "";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function DeleteData($Idx)
    {
        $Query = $this->GetDeleteSQL($Idx);
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access : public
     * Insert, Update, Delete.
     * -------------------------------------------------- */
    function AffectOperate($Query)
    {
        $Ret = false;
        $Result = $this->m_DbMan->Query($Query);
        if($Result)
        {
            if($this->m_DbMan->affected_rows() > 0)
            {
                $Ret = true;
            }
            else
            {
                $this->m_ErrCode = $this->QUERY_RESULT_ZERO;
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     * Check Database Table
     * -------------------------------------------------- */
    function IsExistTable($TableName)
    {
        $Tables = $this->m_DbMan->tableNames();
        if(!empty($Tables))
            return in_array($TableName, $Tables);
        else
            return false;
    }


    /* --------------------------------------------------
     * access : public
     * Create Default Table
     * -------------------------------------------------- */
    function ExecuteQuery($Query)
    {
        $Ret = false;
        $Result = $this->m_DbMan->Query($Query);
        if($Result)
        {
            $Ret = true;
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : protected
     * virtual
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {

    }


    /* --------------------------------------------------
     * access : protected.
     * virtual function.
     * -------------------------------------------------- */
    function GetSelectSQL($Id)
    {
        return " ";
    }


    /* --------------------------------------------------
     * return value : bool type
     *              : fail return false
     *              : Success return true;
     * -------------------------------------------------- */
    function LoadData($Id)
    {
        $Ret = false;
        //flexible GetSelectSQL. use call_user_method
        $Query = call_user_method($this->fpSelectSQL, $this, $Id);
        
        $Result = $this->m_DbMan->Query($Query);
        if($Result)
        {
            if($this->m_DbMan->next_record())
            {                
                $this->LoadMemberValue($this->m_DbMan);
                $Ret = true;
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : protected.
     *          - virtual function
     * Return Default SQL
     * -------------------------------------------------- */
    function GetCreateSQL()
    {
        return "";
    }


    /* --------------------------------------------------
     * access : protected.
     *          - virtual function
     * Initialized Insert Data SQL.
     * -------------------------------------------------- */
    function InitialInsertSQL()
    {
        return "";
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * 
     * -------------------------------------------------- */    
    function SetOperation($Operation)
    {
        switch($Operation)
        {
            case $this->OPERATION_INSERT:
                $this->m_Operation = $this->OPERATION_INSERT;
                break;
            case $this->OPERATION_UPDATE:
                $this->m_Operation = $this->OPERATION_UPDATE;
                break;
            case $this->OPERATION_DELETE:
                $this->m_Operation = $this->OPERATION_DELETE;
                break;
            case $this->OPERATION_SELECT:
                $this->m_Operation = $this->OPERATION_SELECT;
                break;
            default :
                $this->m_Operation = null;
                break;                                                                
        }       
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function SetOperationInsert()
    {
        $this->SetOperation($this->OPERATION_INSERT);
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function SetOperationUpdate()
    {
        $this->SetOperation($this->OPERATION_UPDATE);
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function SetOperationDelete()
    {
        $this->SetOperation($this->OPERATION_DELETE);
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function SetOperationSelect()
    {
        $this->SetOperation($this->OPERATION_SELECT);
    }            
}
?>
