<?php
/*
 * Session Management for PHP3
 *
 * Copyright (c) 2000 Robert Sosnowski (robsosno@wbk.com.pl)
 *
 *
 * $Id: db_informix.inc,v 1.2 2001/03/02 18:22:34 kk Exp $
 *
 */

define("KCINFODBSQL", true);
class KCInfoDbSql {

  /* public: connection parameters */
  var $Host     = "his";
  var $Database = "edujj";
  var $User     = "coms";
  var $Password = "coms";

  /* public: configuration parameters */
  var $Auto_Free     = 0;     ## Set to 1 for automatic ifx_free_result()
  var $Debug         = 0;     ## Set to 1 for debugging messages.
  var $Halt_On_Error = "yes"; ## "yes" (halt with message), "no" (ignore errors quietly), "report" (ignore errror, but spit a warning)
  var $Seq_Table     = "db_sequence";

  /* public: result array and current row number */
  var $Record   = array();
  var $Row;

  /* public: current error number and error text */
  var $Errno    = 0;
  var $Error    = "";

  /* public: this is an api revision, not a CVS revision. */
  var $type     = "informix";
  var $revision = "1.2";

  /* private: link and query handles */
  var $Link_ID  = 0;
  var $Query_ID = 0;

  /* private : blob data */
  var $m_BlobDataIds  ; //array()
  var $m_TranFlag = false ; // transaction flag



  function KDB_Sql()
  {
        ifx_textasvarchar(1);
  }

  /* public: constructor */
  function DB_Sql($query = "") {
      $this->query($query);
  }

  /* public: some trivial reporting */
  function link_id() {
    return $this->Link_ID;
  }

  function query_id() {
    return $this->Query_ID;
  }

  /* public: connection management */
  function connect($Database = "", $Host = "", $User = "", $Password = "") {
    /* Handle defaults */
    if ("" == $Database)
      $Database = $this->Database;
    if ("" == $Host)
      $Host     = $this->Host;
    if ("" == $User)
      $User     = $this->User;
    if ("" == $Password)
      $Password = $this->Password;

    if ($this->Debug)
      printf("Debug: connection params = %s:%s:%s<br>\n",
        $Database, $Host, $User);

    /* establish connection, select database */
    if ( 0 == $this->Link_ID ) {

      if ($Host != "") {
	if (strpos($host, "@") == false) {
	  $this->Link_ID=ifx_pconnect($Database . "@" . $Host, $User, $Password);
	  if (!$this->Link_ID) {
	    $this->halt("cannot connect with ". $Database . "@" . $Host . ":" .ifx_errormsg());
    	    return 0;
	  }
	} else {
	  $this->Link_ID=ifx_pconnect($Database . $Host, $User, $Password);
	  if (!$this->Link_ID) {
	    $this->halt("cannot connect with ". $Database . $Host . ":" .ifx_errormsg());
    	    return 0;
	  }
	}
      } else {
	$this->Link_ID=ifx_pconnect($Database, $User, $Password);
	if (!$this->Link_ID) {
          $this->halt("cannot connect with ". $Database . ":" .ifx_errormsg());
          return 0;
	}
      }

    }

    return $this->Link_ID;
  }

  /* public: discard the query result */
  function free() {
      @ifx_free_result($this->Query_ID);
      $this->Query_ID = 0;
  }

  /* public: perform a query */
  function query($Query_String) {
    /* No empty queries, please, since PHP4 chokes on them. */
    if ($Query_String == "")
      /* The empty query string is passed on from the constructor,
       * when calling the class without a query, e.g. in situations
       * like these: '$db = new DB_Sql_Subclass;'
       */
      return 0;

    if (!$this->connect()) {
      return 0; /* we already complained in connect() about that. */
    };

    # New query, discard previous result.
    if ($this->Query_ID) {
      $this->free();
    }

    if ($this->Debug)
      printf("Debug: query = %s<br>\n", $Query_String);

    //blob Ÿ  ó
    if( func_num_args() == 2)
    {
        $blobIds = func_get_arg(1);
        $this->Query_ID = ifx_query($Query_String, $this->Link_ID, $blobIds);
    }
    // blob Ÿ  
    else
    {
        $this->Query_ID = ifx_query($Query_String,$this->Link_ID);
    }


    $this->Row   = 0;
    $this->Errno = ifx_error();
    $this->Error = ifx_errormsg();
    if (!$this->Query_ID) {
      $this->halt("Invalid SQL: ".$Query_String);
    }

    # Will return nada if it fails. That's fine.
    return $this->Query_ID;
  }

  /* public: walk result set */
  function next_record() {
    if (!$this->Query_ID) {
      $this->halt("next_record called with no query pending.");
      return 0;
    }

    $this->Record = ifx_fetch_row($this->Query_ID);
    $this->Row   += 1;
    $this->Errno  = ifx_error();
    $this->Error  = ifx_errormsg();

    $stat = is_array($this->Record);
    if (!$stat && $this->Auto_Free) {
      $this->free();
    }
    return $stat;
  }

  /* public: position in result set */
  function seek($pos = 0) {
    return 1;
  }

  /* public: table locking */
  function lock($table, $mode="write") {
    if ($mode == "write") {
      $result = ifx_query("lock table $table in exclusive mode", $this->Link_ID );
    } else {
      $result = 1;
    }
    return $result;
  }

  function unlock() {
    $result = ifx_query("commit work", $this->Link_ID );
    return $result;
  }


  /* public: evaluate the result (size, width) */
  function affected_rows() {
    return ifx_affected_rows($this->Query_ID);
  }

  function num_rows() {
    return ifx_num_rows($this->Query_ID);
  }

  function num_fields() {
    return ifx_num_fields($this->Query_ID);
  }

  /* public: shorthand notation */
  function nf() {
    return $this->num_rows();
  }

  function np() {
    print $this->num_rows();
  }

  function f($Name) {
    return $this->Record[$Name];
  }

  function p($Name) {
    print $this->Record[$Name];
  }

  /* public: sequence numbers */
  function nextid($seq_name) {
    $this->connect();

    if ($this->lock($this->Seq_Table)) {
      /* get sequence number (locked) and increment */
      $q  = sprintf("select nextid from %s where seq_name = '%s'",
                $this->Seq_Table,
                $seq_name);
      $id  = ifx_query($q, $this->Link_ID);
      $res = ifx_fetch_row($id);
      ifx_free_result($id);

      /* No current value, make one */
      if (!is_array($res)) {
        $currentid = 0;
        $q = sprintf("insert into %s values('%s', %s)",
                 $this->Seq_Table,
                 $seq_name,
                 $currentid);
        $id = ifx_query($q, $this->Link_ID);
      } else {
        $currentid = $res["nextid"];
      }
      $nextid = $currentid + 1;
      $q = sprintf("update %s set nextid = '%s' where seq_name = '%s'",
               $this->Seq_Table,
               $nextid,
               $seq_name);
      $id = ifx_query($q, $this->Link_ID);
      $this->unlock();
    } else {
      $this->halt("cannot lock ".$this->Seq_Table." - has it been created?");
      return 0;
    }
    return $nextid;
  }

  /* public: return table metadata */
  function metadata($table='',$full=false) {
    $count = 0;
    $id    = 0;
    $res   = array();

    /*
     * Due to compatibility problems with Table we changed the behavior
     * of metadata();
     * depending on $full, metadata returns the following values:
     *
     * - full is false (default):
     * $result[]:
     *   [0]["table"]  table name
     *   [0]["name"]   field name
     *   [0]["type"]   field type
     *   [0]["len"]    field length
     *   [0]["flags"]  field flags ("NOT NULL")
     *   [0]["format"] precision and scale of number (eg. "10,2") or empty
     *
     * - full is true
     * $result[]:
     *   ["num_fields"] number of metadata records
     *   [0]["table"]  table name
     *   [0]["name"]   field name
     *   [0]["type"]   field type
     *   [0]["len"]    field length
     *   [0]["flags"]  field flags ("NOT NULL")
     *   [0]["format"] precision and scale of number (eg. "10,2") or empty
     *   ["meta"][field name]  index of field named "field name"
     *   The last one is used, if you have a field name, but no index.
     *   Test:  if (isset($result['meta']['myfield'])) {} ...
     */

    // if no $table specified, assume that we are working with a query
    // result
    $query_tablename="query stmt";
    if ($table) {
      $this->connect();
      $id = ifx_query("select * from $table", $this->Link_ID );
      if (!$id) {
	$this->Error  = ifx_errormsg();
	$this->Errno  = ifx_error();
	$this->halt("Metadata query failed.");
      }
    } else {
      $id = $this->Query_ID;
      $table=$query_tablename;
      if (!$id)
        $this->halt("No query specified.");
    }

    $count = ifx_num_fields($id);

    // made this IF due to performance (one if is faster than $count if's)
    if (!$full) {
      $info=ifx_fieldproperties($id);
      for ($i=0; $i<$count; $i++) {
        $fname = key ($info);
	list($ifx_type, $ifx_len, $ifx_prec, $ifx_scale, $ifx_nullable) = explode(";", $info[$fname]);
        $res[$i]["table"] = $table;
        $res[$i]["name"]  = $fname;
        $res[$i]["type"]  = $ifx_type;
        $res[$i]["len"]   = $ifx_len;
        $res[$i]["flags"] = ($ifx_nullable == 'N') ? 'NOT NULL' : '';
        $res[$i]["format"]=  $ifx_prec.",".$ifx_scale;
        if ("0,0"==$res[$i]["format"]) $res[$i]["format"]='';
	next($info);
      }
    } else { // full
      $res["num_fields"]= $count;
      $info=ifx_fieldproperties($id);
      for ($i=0; $i<$count; $i++) {
        $fname = key ($info);
	list($ifx_type, $ifx_len, $ifx_prec, $ifx_scale, $ifx_nullable) = explode(";", $info[$fname]);
        $res[$i]["table"] = $table;
        $res[$i]["name"]  = $fname;
        $res[$i]["type"]  = $ifx_type;
        $res[$i]["len"]   = $ifx_len;
        $res[$i]["flags"] = ($ifx_nullable == 'N') ? 'NOT NULL' : '';
        $res[$i]["format"]=  $ifx_prec.",".$ifx_scale;
        if ("0,0"==$res[$i]["format"]) $res[$i]["format"]='';
        $res["meta"][$fname] = $i;
	next($info);
      }
    }

    // free the result only if we were called on a table
    if ($table != $query_tablename) ifx_free_result($id);
    return $res;
  }

  /* private: error handling */
  function halt($msg) {
    $this->Error = ifx_errormsg();
    $this->Errno = ifx_error();
    if ($this->Halt_On_Error == "no")
      return;

    $this->haltmsg($msg);

    if ($this->Halt_On_Error != "report")
    {
      // transaction ̸ rollback Ѵ.
      if($this->m_TranFlag == true)
      {
        $this->rollback();
      }

      die("Session halted.");
    }

  }

  function haltmsg($msg) {
    printf("</td></tr></table><b>Database error:</b> %s<br>\n", $msg);
    printf("<b>Informix Error</b>: %s (%s)<br>\n",
      $this->Errno,
      $this->Error);
  }

  function table_names() {
    $this->connect();
    $id = ifx_query("select tabname from systables where tabid>=100 and tabtype='T'", $this->Link_ID );
    $i=0;
    while ($info=ifx_fetch_row($id))
     {
      $return[$i]["table_name"]= $info["tabname"];
      $return[$i]["tablespace_name"]=$this->Database;
      $return[$i]["database"]=$this->Database;
      $i++;
     }
   ifx_free_result($id);
   return $return;
  }

  function begin() {
    $result=ifx_query("begin work", $this->Link_ID );
    $this->m_TranFlag = true ;
    return $result;
  }

  function commit() {
    $result=ifx_query("commit work", $this->Link_ID );
    $this->m_TranFlag = false ;
    return $result;
  }

  function rollback() {
    $result=ifx_query("rollback work", $this->Link_ID );
    $this->m_TranFlag = false ;
    return $result;
  }

  //blob Ÿ setting
  function m_SetBlobDataIds($param)
  {
        $offset = count($this->m_BlobDataIds);
        $this->m_BlobDataIds[$offset] = ifx_create_blob(1, 0, $param);
  }

  function m_GetBlobDataIds()
  {
        return $this->m_BlobDataIds ;
  }
}
?>
