<?
/*
 ************************************************************************
 * File Name   : KCSqlClause.php
 * Class Name  : KCSqlClause
 * version     : 0.2
 * Copyright   : 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * Comment     : This class is for MySQL.
 * This class provide Oracle SQL Syntex.
 * Update Date : 2003.07.28
 ************************************************************************
 */

if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
if(!defined("KCPAGING"))      require(K_LIB_PATH . "/KCPaging.php");

define("KCSQLCLAUSE", true);
class KCSqlClause extends KCCommonClass
{
    var $debug = false ;
    var $m_Where ;              // ǹ ϰ 
    var $m_Table ;              // table 
    var $m_Field ;              // field 
    var $m_GroupBy;
    var $m_Order ;              // order clause 
    var $m_OffSet ;             //   
    var $m_Rows ;               // Ʈ  µǴ row 
    var $m_Operator ;           // Where      ̰   "or" or "and"
    var $m_Paging ;
    var $m_CountField;    
    var $m_SortKey = null;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCSqlClause($CountField = "*")
    {
        $this->KCCommonClass();
        $this->m_Paging     = new KCPaging;
        $this->m_Operator   = "AND"; // 'AND', 'OR'
        $this->m_CountField = $CountField;
        $this->m_OffSet     = null;
    }


    /* --------------------------------------------------
     * access : public
     * Set Where Clause
     * -------------------------------------------------- */
    function SetWhere($data)
    {
        //Էµ Ÿ   ٷ 
        if($data == "")
        {
            return ;
        }
        $count = count($this->m_Where);
        $this->m_Where[$count] = $data ;
    }


    /* --------------------------------------------------
     * access : public
     * Where  Ͽ մϴ.
     * -------------------------------------------------- */
    function GetWhere()
    {
        //   ٸ ٷ ϰ
        if(count($this->m_Where) == 0)
        {
            return ;
        }
        //׷   where  Բ  Էµ  Ͽ ϳ clause ش.
        else
        {
            $clauses = " WHERE ";
            // ǹ ϳ string  ġ  
            for($i = 0 ; $i < count($this->m_Where) ; $i ++)
            {
                $clauses .= $this->m_Where[$i] ;
                if( ($i + 1) < count($this->m_Where))
                    $clauses .= " " .$this->GetOperator(). " ";
            }
        }
        return $clauses ;
    }


    /* --------------------------------------------------
     * access : public
     * ڸ   'or' Ǵ 'and' 
     * -------------------------------------------------- */
    function SetOperator($operator)
    {
        if($operator == "or" || $operator == "and")
        {
            $this->m_Operator = $operator;
        }
        else
        {
            $this->m_Operator = "and" ;
        }
    }


    /* --------------------------------------------------
     * access : protected
     * ڸ 
     * -------------------------------------------------- */
    function GetOperator()
    {
        return $this->m_Operator ;
    }


    /* --------------------------------------------------
     * access : public
     * sql select Ǿ field մϴ.
     * ʵ   · Ѿ͵  ','  ˴ϴ.
     *  ) $sql->m_SetField("na"); <-
     *       $sql->m_SetField("na, Jong") ; <- 
     *       $sql->m_SetField("na, jong ", "sung, konlo ") ; <- 
     * -------------------------------------------------- */
    function SetField()
    {
        $start_index = count($this->m_Field);

        //Ѿ arg ʷ parsing  
        for($i = 0 ; $i < func_num_args() ; $i ++)
        {
            // arg ٽ ',' и Ͽ Ÿ 
            $field = func_get_arg($i) ;
            $field = explode(",", $field );
            for($j = 0 ; $j < count($field) ; $j ++)
            {
                $this->m_Field[$start_index++] =$field[$j];
            }
        }
    }


    /* --------------------------------------------------
     * access : public
     *   field Ͽ մϴ.
     * ʵ̿ ',' ϴ.
     * -------------------------------------------------- */
    function GetField()
    {
        for($i = 0 ; $i < count ($this->m_Field) ; $i ++)
        {
            $field .= $this->m_Field[$i] ;
            if($i + 1 < count($this->m_Field) )
            {
                $field .=" , " ;
            }
        }
        return $field ;
    }


    /* --------------------------------------------------
     * access : public
     * sql select Ǿ table մϴ.
     *   m_SetField()Լ ϴ.
     * -------------------------------------------------- */
    function SetTable()
    {
        $start_index = count($this->m_Table);

        //Ѿ arg ʷ parsing  
        for($i = 0 ; $i < func_num_args() ; $i ++)
        {
            // arg ٽ ',' и Ͽ Ÿ 
            $table = func_get_arg($i) ;
            $table = explode(",", $table );

            for($j = 0 ; $j < count($table) ; $j ++)
            {
                $this->m_Table[$start_index++] =$table[$j];
            }
        }
    }


    /* --------------------------------------------------
     * access : public
     * table   ',' Ͽ 
     * -------------------------------------------------- */
    function GetTable()
    {
        for($i = 0 ; $i < count ($this->m_Table) ; $i ++)
        {
            $table .= $this->m_Table[$i] ;
            if($i + 1 < count($this->m_Table) )
            {
                $table .=" , " ;
            }
        }
        
        return $table. " " . $this->GetUseKey() ;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetGroupBy($GroupBy)
    {
        $this->m_GroupBy = $GroupBy;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetGroupBy()
    {
        return $this->m_GroupBy;
    }


    /* --------------------------------------------------
     * access : public
     * order  شϴ κ ϱ
     * -------------------------------------------------- */
    function SetOrder($order_clause)
    {
        $this->m_Order = "$order_clause";
    }


    /* --------------------------------------------------
     * access : protected
     * order  
     * -------------------------------------------------- */
    function GetOrder()
    {
        return $this->m_Order ;
    }


    /* --------------------------------------------------
     * access : private
     *  row ϴ
     *  Ʈ  row ڷ .
     * -------------------------------------------------- */
    function SetLimit($rows)
    {
        $this->m_Paging->SetListPerPage($rows);
    }


    /* --------------------------------------------------
     * access : protected 
     *
     * -------------------------------------------------- */
    function InitPaging($PageFlag = true)
    {
        $this->m_Paging->InitPaging($this->GetTable(), $this->GetWhere(), $this->GetCountField(), $PageFlag);
        $this->m_OffSet = $this->m_Paging->GetOffSet(); // rownum  1 ̹Ƿ 1 
        $this->m_Rows   = $this->m_Paging->GetListPerPage() ;
    }


    /* --------------------------------------------------
     * access : protected
     *  и ؼ ʿ row    ֵ between Ѵ.
     *  oracle ϱ ؼ Ѵ.
     * mysql ؼ $start_offset  Ѵ.
     * virtual
     * -------------------------------------------------- */
    function GetLimit()
    {
        $start_offset = $this->m_OffSet + 1 ;
        $end_offset   = $this->m_OffSet + $this->m_Rows ;
        return "LIMIT $this->m_OffSet, $this->m_Rows ";
    }


    /* --------------------------------------------------
     * access : public
     * ߿ ϴ ġ   
     * query  ۼѴ.
     * -------------------------------------------------- */
    function GetListQuery($rows = 15)
    {
        $this->SetLimit($rows);
        $this->InitPaging();
        $query = "SELECT " . $this->GetField(). " FROM ".  $this->GetTable() . " ". $this->GetWhere() . " " . $this->GetGroupBy() . " " . $this->GetOrder() ." ". $this->GetLimit();
        return $query ;
    }


    /* --------------------------------------------------
     * access :
     * ߿ ϴ ġ   
     * query  ۼѴ.
     * -------------------------------------------------- */
    function GetQuery()
    {
        $this->InitPaging(false);
        $query =   " SELECT " . $this->GetField()  ;
        $query .=  " FROM " . $this->GetTable() . " ". $this->GetWhere() . " " . $this->GetGroupBy() . " " . $this->GetOrder() ;
        return $query ;
    }


    /* --------------------------------------------------
     * access :
     * Ʈ query ϱ
     * -------------------------------------------------- */
    function GetStripField()
    {
        for($i = 0 ; $i < count ($this->m_Field) ; $i ++)
        {
            //field    '.'  иϿ ޺κ ʵ ̸ Ѵ.
            $field_temp = $this->m_Field[$i] ;
            $field_temp = explode(".", $field_temp);
            if($field_temp[1] != "")
            {
                $field .= $field_temp[1]; //޺κ ʵ ̸ 
            }
            else
            {
                $field .= $field_temp[0]; //  aa.bb° ƴϸ
            }

            if($i + 1 < count($this->m_Field) )
            {
                $field .=" , " ;
            }
        }
        return $field ;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetCountField()
    {
        return $this->m_CountField;
    }


    /* --------------------------------------------------
     * access :  public
     *
     * -------------------------------------------------- */
    function SetListPerPage($Value)
    {
        $this->m_Paging->SetListPerPage($Value);
    }


    /* --------------------------------------------------
     * access :  public
     *
     * -------------------------------------------------- */
    function SetPrintPageNum($Value)
    {
        $this->m_Paging->SetPrintPageNum($Value) ;
    }


    /* --------------------------------------------------
     * access :  public
     *
     * -------------------------------------------------- */
    function GetPaging()
    {
        return $this->m_Paging;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetStartListNum()
    {
        return $this->m_Paging->GetStartListNum();
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function PrintPageNum()
    {
        return $this->m_Paging->PrintPageNum();
    }
    
    
    /* --------------------------------------------------
     * access : public
     * KEY 
     * -------------------------------------------------- */            
    function SetUseKey($Key)
    {
        $this->m_SortKey  =$Key;
    }    
    

    /* --------------------------------------------------
     * access : public
     * KEY 
     * -------------------------------------------------- */                
    function GetUseKey()
    {
        if($this->m_SortKey != null)
        {
            return "USE KEY ($this->m_SortKey)";
        } 
    }
}
?>
